// Author: Torsten.Leitner@email.de
// (c) 2006/2007


#ifndef GASTARGETIONIZATION_H_
#define GASTARGETIONIZATION_H_

#include <stdio.h>
#include <iostream>
#include <iomanip>
#include <fstream>
#include <string>
#include <cstring>
#include <cstdlib>
#include <math.h>

#include <complex>
#include <vector>
#include <gsl/gsl_math.h>
#include <gsl/gsl_sf_gamma.h>

#include "tArrayComplex2D_rt.h"

#include "Constants.h"
#include "logbuch.h"


using namespace std;

// static const double TIR_ADK_CONSTANT_A	= 1.51926778e15;
static const double TIR_ADK_CONSTANT_B	= 2.04926724e10;

int Elementwise_Exp_minus_X(        double  **X, int Nr, int Ntw);
int Elementwise_Exp_minus_X(Complex **X, int Nr, int Ntw);

double TIR_fit_Ne(const double E_in);
double TIR_fit_He(const double E_in);
double TIR_ADK   (const double E_in, const double Ip, const int Z);


int Integral_TIR_AmmosovDeloneKrainov(double **ExpIntTir, class tArrayComplex2D_rt *Laser, double Ip, int Z);

int Integral_TIR_AmmosovDeloneKrainov(double **ExpIntTir, Complex **E, double dt,int Nr, int Ntw, double Ip, int Z);

//inline int TunnelIonisationRate(double **tir, Complex **E, int Nr, int Nt, double Ip, double Z);






#endif /*GASTARGETIONIZATION_H_*/
