// Author: Torsten.Leitner@email.de
// (c) 2006/2007


#include "NonlinearDipoleMoment.h"


using namespace std;


using namespace std;

/*
int singleatom::test_vecpot()
{
	class VecPot testvecpot;
	
	  double 		xmin    = -3*(laser->taunatural);
	  double 		xmax	= -xmin;
	  double 		dx		= 1e-2;
	  int N_vecpot_accuracy	=  int(1e4);
	  
	
	  testvecpot.init( laser , xmin , xmax , N_vecpot_accuracy );
    
      double x=xmin;
      ofstream File("vecpottest.dat", ios::out|ios::trunc);
      while (x < xmax) {
            
            File << x << " " << laser->at(x) 
            	 	  << " " << testvecpot.at(x) 
            	 	  << " " << testvecpot.Int(xmin,x) 
            	 	  << " " << testvecpot.Int2(xmin,x) 
            	 << endl;
            x+=dx;
      }
      return 0;
}
// */

Complex* 	singleatom::getXwPtr()
{ return xw;}

int 				singleatom::sizeXwPtr()
{ return int(Nt/2); }

double* 			singleatom::getAbsXwPtr()
{
	absXw = new double[int(Nt/2)];
	for (int i=0;i<int(Nt/2);i++) { absXw[i] = abs(xw[i]); } 
	return absXw;
}

int 				singleatom::sizeAbsXwPtr()
{ return int(Nt/2); }

// ******* Begin Constructors ... ********************************************** 
singleatom::singleatom() 
{ 	cout << "Object of class 'singleatom' created and uninitialized ...  " << endl;}

singleatom::singleatom(struct InputParameter *in, class tArrayComplex2D_rt *laserPtr) 
{ 
	laser = laserPtr;
	SetParameter(in->outfile, in,laser);
	cout << "Object of class 'singleatom' created and initialized ...  " << endl;
}
// ******* End Constructors ... ************************************************


// ******* Begin Destructors ... ***********************************************
singleatom::~singleatom() //Destruktoren
{ 
/*	delete xt;
	delete xw;
	delete t;
	delete w0t;*/
	cout << "Object of class 'singleatom' destroyed ... " << endl; 
}
// ******* End Destructors ... *************************************************

// *****************************************************************************
void singleatom::SetParameter(struct InputParameter *in, class tArrayComplex2D_rt *laserPtr)
{
	SetParameter(in->outfile, in,laser);	
}
// *****************************************************************************

// *****************************************************************************
void singleatom::SetParameter(string pname, struct InputParameter *in, class tArrayComplex2D_rt *laserPtr)
{   
//cout << "Beginne SetParameter ... " << endl;
	laser = laserPtr;
	projectname=pname;

// Simulationparams
	setIp(in->Ip);
	setLambda(in->lam);
		
	Qmax=int(0.5 + in->Q);
	dt   = ( M_PI / Qmax );//* inv_w0
	dw=in->abs_omega_error;
	taumin=0;//in->taumin;
	taumax=in->taumax; // taumax -> +inf
	dtau=in->dtau;
	
	Nt	  = 1 + int( double(2*Qmax) / dw );	
	Nw	  = int( 0.5*Nt );
	
	//tmin = in->Tmin;
	tmin = -(0.5*dt*(Nt-1));  // Center around t = 0
	tmax =  tmin + (Nt-1)*dt;
		
	setIntensity(in->Intensity);
	
	//dipMel.init(Ip);	

	//vecpot.init( laser , tmin-taumax, tmax+taumax , in->vecpot_number_of_interpolation_points );
//vecpot.init( laser ); // => init(laser,-3*(laser->taunatural),+3*laser->taunatural,Nmax);

//cout << "singleatom::SetParameter done ... " << endl;
}
// *****************************************************************************

void singleatom::setIp(double x)
{	Ip=x;}
// *****************************************************************************
void singleatom::setLambda(double x)
{
	lam 	= x;
	w0  	= (2*PI) * CLIGHT / lam;
	inv_w0  = 1/w0;	
}
// *****************************************************************************
void singleatom::setIntensity(double x)
{	
	Intensity = x;
	
	//in [lew] Einheiten:
	E0 = 100 * sqrt(  Intensity * GSL_CONST_MKSA_PLANCKS_CONSTANT_H / (lam * GSL_CONST_MKSA_VACUUM_PERMITTIVITY) );
		
	//in SI-Einheiten: E[V/m]
	//E0 = 100 * sqrt(  Intensity / (GSL_CONST_MKSA_SPEED_OF_LIGHT * GSL_CONST_MKSA_VACUUM_PERMITTIVITY) );
		// I[W/m2] = epsi0 * c * E^2 ;
	// -> I[W/cm2] = 1e-4 * epsi0 * c * E^2 ;
	// I[lew] = I[W/m2] * h*c/lam = 1e4 * I[W/cm2] * h*c/lam 
	// E[V/m] = 100 * sqrt( I[W/cm2]/eps0*c ); 
	// E[lew] = E[V/m]*sqrt(hbar*omega) = E[V/m]*sqrt(h*c/lam)
	// **** -> E[lew] = 100 * sqrt( I[W/cm2] * h / lam*eps0 ) ****
	// Ip[lew] = Ip[*]/hbar*omega0[*]
	
	Up = .25*E0*E0 ;//* inv_w0;  // inv_w0 = 1/w0
	//Ip = Ip * (GSL_CONST_MKSA_PLANCKS_CONSTANT_H * w0 / (2*M_PI)) ;
	
	if(Up <= Ip){cout << "\n***\nYou're not in the Tunneling-Regime!\n***\n" <<endl;}
	//1/(2*M_PI); // 1==w0=(2pi c/lam) -> lam = 1/2pi (hbar=c=m=e=w0=1)
}
// *****************************************************************************


// Function to integrate ...
// *****************************************************************************
double singleatom::dipIntegrand(const double t, const double tau, const double E0)
{	
		Complex integrand;
		Complex ImagUnit(0,1);
	
//		double alpha=2*Ip; //from P.Antoine et.al. -> PhRevA,Vol.53#3,March1996

		if(tau==0) 
			{  Pstat=0; Sstat=0;  }
		else 
		{	
			Pstat = E0 ;//* vecpot.Int(t-tau,t) / tau ;
		 	Sstat = ( Ip + 0.5*Pstat*Pstat )*tau ;//  +   0.5*E0*E0 * vecpot.Int2(t-tau,t) ;
		}

		Complex prefactor(REGULARIZATION_CONST_TAUINTEGRAL,0.5*tau); //epsilon+i*tau/2
				    
		prefactor = pow((PI/prefactor),1.5); // ( pi / epsilon+i*tau/2 )^(3/2)

		integrand = ImagUnit * prefactor ;
//				  * 	     E0 *   laser->at(t-tau) 
//				  *         dipMel.at(  Pstat - E0 * vecpot.at(t) 	 )
//				  * conj(   dipMel.at(  Pstat - E0 * vecpot.at(t-tau) )   ) 
//			  	  * 		  exp    ( -ImagUnit * Sstat );	
	
		return (2 * integrand.real()); // 2*RealPart(Integrand)
}
// *****************************************************************************
// End of function to integrate ...

// *****************************************************************************
double singleatom::dipBodeIntegral(const double t, int Ntauu)
{ /// Bode's Rule: See Numerical Recipes p.136
  /// \int_{x0}^{x4} dx f(x) = (h/45) * [14(f0+f4) + 64(f1+f3) + 24f2] + O[dtau^7 * f^(6)];

//  double singleatom:dipIntegrand(const double t, const double tau, const double w,  const double E)
/*
	taumin=LOWER_TAU;//-100;  
	taumax=UPPER_TAU;//0;   // a=- .. b=big->inf
	dtau=DTAU; // Integrationstep
// */
	Ntau = Ntauu;
//cout << "Starte dipBodeIntegral ... Ntau = "<<Ntau <<" -- dtau "<<dtau<< endl;

	double f24=0,f28=0,f64=0;

	double result=0;
	result+=14*( dipIntegrand( t , taumin , E0 )
				+dipIntegrand( t , taumax , E0 ) );
	int j;
	for (j=1;j<(Ntau/4);j++)
	{
		f24 +=   dipIntegrand( t ,(4*j-2)*dtau, E0 );
		f28 +=   dipIntegrand( t ,(4*j  )*dtau, E0 );
		f64 +=   dipIntegrand( t ,(2*j-1)*dtau, E0 );		
	} //loop to j=(Ntau/4)-1 -> f28 fine
	// j++ is done one more time by for-loop without executing the function -> j=Ntau/4
	f64 +=  dipIntegrand( t ,(2*j-1)*dtau, E0 );
	f24 +=  dipIntegrand( t ,(4*j-2)*dtau, E0 ); //loop to j=Ntau/4 -> f24 fine
	j++; // -> j=(Ntau/4)+1
	for (int k=j;k<(Ntau/2)+1;k++)
	{
		f64 +=   dipIntegrand(t ,(2*j-1)*dtau, E0 );
	} //loop to j=(Ntau/2) -> f64 fine
//cout << "dtau "<<dtau<< " f24 "<<f24<<endl; 			
	result += 24*f24 + 28*f28 + 64*f64 ;
	result *= (dtau/45);
	
return result;	
}

// *****************************************************************************
int singleatom::calculate_xt( )
{
	cout << "\n Ich roque ... ( Bode's Integration Rule (5pt-formula) ) \n"<<endl;
	// Error of the Order of O( dtau^7 * f^(6) ) 

	tmax  = tmin + (Nt-1)*dt;
	
	xt   = new double[Nt];
	//dxt  = new double[Nt];
	
	cout << "\n Number of timesteps: "<< Nt <<endl;
	
// Params for the tau-Integration ...
	taumin = 0;	
	int Ntau = 4 * int(0.25*(taumax - taumin) / dtau); // Assure that Ntau mod 4 = 0; (needed for Bode's Integration Rule)
	taumax = taumin + Ntau * dtau; // ReSet upper border ...
	
	cout << "Ntau " << Ntau << " taumin " << taumin << " - taumax " << taumax << endl;
	
	double t=tmin-dt;
	
	double dtsec=  dt  * inv_w0;
	double tsec =   t  * inv_w0;
//		xt[0]=dipBodeIntegral(t,Ntau); 		
///*	
	int i=0;
    for(i=0;i<Nt;i++)
    {
    	t+=dt;  // w*t
    	tsec+=dtsec; // t[sec]
	   	xt[i]=dipBodeIntegral(t,Ntau); 		if( isnan(xt[i])){cout << "xt = NaN at i=" << i << endl;return 1;}
//		outFile 
//				<< setw(15) << t << " "
////				<< setw(15) << tsec << " "
//				<< setw(15) << xt[i]  <<" "
//				<< setw(15) << laser->at(t)  <<" "
//				//<< setw(15) << dxt[i]  <<" "
//				//<< setw(15) << dxt[i]/xt[i]  
//				<< endl;
		if((i % StepsUntilDisplay)==0){cout <<" Step: "<< setw(5)<< i +1 << " of "<< Nt
							 <<"  w0*t = "<< setw(7)<< t
							 <<"  t[s] = "<< setw(11)<<tsec
							 <<"  x(t) = "<< setw(10)<<xt[i]
							 //<<"  dx(t) = "<< setw(12)<<dxt[i]
							 //<<"  (dx/x)(t) = "<< setw(8)<< dxt[i]/xt[i]
							 <<endl;}
	}
	cout <<" Step: "<< setw(5)<< i << " of "<< Nt // Nt=i-1 here, because for-loop increments once to often
							 <<"  w0*t = "<< setw(7)<< t
							 <<"  t[s] = "<< setw(11)<<tsec
							 <<"  x(t) = "<< setw(10)<<xt[i]
							 //<<"  dx(t) = "<< setw(12)<<dxt[i]
							 //<<"  (dx/x)(t) = "<< setw(8)<< dxt[i]/xt[i]
							 <<endl;
// */
	cout << "\n Endlich fertisch ... \n"<<endl;
	
	return 0;
}	
// *****************************************************************************



