// Author: Torsten.Leitner@email.de
// (c) 2006/2007

#ifndef NONLINEARDIPOLEMOMENT_H_
#define NONLINEARDIPOLEMOMENT_H_


#include <stdio.h>
#include <iostream>
#include <iomanip>
#include <fstream>
#include <string>
#include <cstring>
#include <cstdlib>
#include <math.h>

#include <complex>
#include <vector>
#include <gsl/gsl_math.h>
#include <gsl/gsl_sf_gamma.h>

#include "tArrayComplex2D_rt.h"

#include "Constants.h"
#include "options.h"
#include "logbuch.h"

using namespace std;


using namespace std;
/******************************************************************************/
/*  Functions used mainly by this class ...                                   */
/******************************************************************************/


inline Complex dipMatrixElement(const double p, const double Ip);


/******************************************************************************/
/*  End of Functions used mainly by this class ...                            */
/******************************************************************************/




/******************************************************************************/
/*  Class definition ...                                                      */
/******************************************************************************/
class singleatom
{
	
public:
	//functions and methods
	
      int test_vecpot();
      
      Complex* 	getXwPtr();
      int 				sizeXwPtr();
      
      double* 			getAbsXwPtr();
      int 				sizeAbsXwPtr();

/******************************************************************************/	
//Konstruktors:
	singleatom();
 	singleatom(struct InputParameter *in, class tArrayComplex2D_rt *laserPtr);
/******************************************************************************/		
//Destruktors	
	virtual ~singleatom(); 
/******************************************************************************/	
	void SetParameter(struct InputParameter *in, class tArrayComplex2D_rt *laserPtr);
	
	void SetParameter(string pname, struct InputParameter *in, class tArrayComplex2D_rt *laserPtr);

/******************************************************************************/	
	
	void setIp		 (double x);
	void setLambda	 (double x);
	void setIntensity(double x);

/******************************************************************************/	
	double dipole_time_hydro_x_bode(double taumin, double taumax, double dtau);

/******************************************************************************/	
	int calculate_xt( );					  
	//int calculate_xt(int inQmax, double abs_omega_error, double intmin,
			//		 double intaumin, double intaumax, double indtau  );	
							   						  

	//variables
	double *xt, *dxt;
	Complex *xw;
	double *absXw;
	
	// Ptr: x(t) und x(w), t[s], w0t[rad]=omega0[Hz]*t[s]
	
	
	string projectname;	
	
	long int Ntau;
	
	class tArrayComplex2D_rt *laser;
	
	int    Nt,Nw,Qmax;
		
private:
	//variables
	//class VecPot vecpot;
	//class DipoleMatrixElement dipMel;
	
	double Intensity,E0,Ip,Up;
	double lam,w0,dw;
	double lifetime;
	
	//double *VecPot;
	//vector<double > VecPot;
		
	double dt,tmax,tmin;
	
	double inv_w0;
	double taumin,taumax,dtau;
	
	double Pstat,Sstat,IntA,IntAA;
		
//functions
	inline Complex dipole_mel_hydro_x(const double p);
	double dipIntegrand(const double t, const double tau, const double E0);
	double dipBodeIntegral(const double t, int Ntauu);
	int save_xt_headeronly(void);
	
	int SupplyVecPotArray();
	
	inline Complex DipoleMatrixElement_Hydrogen(const double p);		
	

		
// intern function_pointers		
//	Complex (singleatom::* dipMelPtr)(double p);
		// Pointer to the VectorPotential A' = A/ E0
//	double 	(singleatom::* VecPotPtr)(const double t, const double lifetime);
		// Pointer to the Integrals over A'(t) and A'(t)^2  , with A' = A/E0
//	int (singleatom::* VecPotIntegralsPtr)(double *IntA,double *IntAA,const double t,const double tau,const double lifetime);
	

};


#endif /*NONLINEARDIPOLEMOMENT_H_*/

