// Author: Torsten.Leitner@email.de
// (c) 2006/2007


#ifndef EVOLVE_H_
#define EVOLVE_H_


#include <stdio.h>
#include <iostream>
#include <iomanip>
#include <fstream>
#include <string>
#include <cstring>
#include <cstdlib>
#include <math.h>

#include <complex>
#include <vector>
#include <gsl/gsl_math.h>
#include <gsl/gsl_sf_gamma.h>

#include "tArrayComplex2D_rt.h"

#include "tArrayComplex3D_xyt.h"

#include "Constants.h"


using namespace std;



int evolve2d_fullAU(int nsteps, double dzAU, class tArrayComplex2D_rt *u, class tArrayComplex2D_rt *source);


int evolve2d  ( int nsteps, double dz, class tArrayComplex2D_rt  *u, class tArrayComplex2D_rt  *source );



int evolve3d_tiloadi( int nsteps, double dz, class tArrayComplex3D_xyt *u, class tArrayComplex3D_xyt *source );

int evolve3d_FTCS( int nsteps, double dz, class tArrayComplex3D_xyt *u, class tArrayComplex3D_xyt *source );

int evolve3d  ( int nsteps, double dz, class tArrayComplex3D_xyt *u, class tArrayComplex3D_xyt *source );
	
int evolve3d_halfstep_x( double dz, class tArrayComplex3D_xyt *u, class tArrayComplex3D_xyt *source 
							,const int idx, const int idy,const int jt
							, const Complex alpha, const Complex beta0, Complex *beta, Complex *b );


int evolve3d_halfstep_y( double dz, class tArrayComplex3D_xyt *u, class tArrayComplex3D_xyt *source 
							,const int idx, const int idy,const int jt
							, const Complex alpha, const Complex beta0, Complex *beta, Complex *b );




#endif /*EVOLVE_H_*/


