// Author: Torsten.Leitner@email.de
// (c) 2006/2007


#ifndef FFTW_FFT_H_
#define FFTW_FFT_H_




#include <stdio.h>
#include <iostream>
#include <iomanip>
#include <fstream>
#include <string>
#include <math.h>
#include <complex>
#include <vector>
#include <gsl/gsl_const_mksa.h>
#include <gsl/gsl_math.h>
//#include <gsl/gsl_complex.h>
//#include <gsl/gsl_complex_math.h>
//#include <gsl/gsl_sf_bessel.h>
#include <gsl/gsl_errno.h>

#include <fftw3.h>

#include "Definitions.h"

using namespace std;

//class fftw
class fftw_fft1d
{
public:
//constructors
	fftw_fft1d();
	fftw_fft1d(int N);
//destructors
	virtual ~fftw_fft1d();
//functions

	int init(int N);

// Do the transformation ...	
	int fft (		Complex   *d);
	int fft (vector<Complex > *d);
	int ifft(		Complex   *d);
	int ifft(vector<Complex > *d);
	int bfft(		Complex   *d);
	int bfft(vector<Complex > *d);

//variables
	int N;
	//int state; // state = 0 : unallocated // state = 1 : t-Space // state = 2 : w-Space
private:
//variables
	int j;
    fftw_complex *in;
	fftw_complex *out;
	fftw_plan forward,backward;
};


#endif /*FFTW_FFT_H_*/
