// Author: Torsten.Leitner@email.de
// (c) 2006/2007



#include "io3d.h"

using namespace std;



// ********************************************************************************************** //
int write_3D_time(class tArrayComplex3D_xyt *feld, char *stdmeshname, int filenr  )
{	
	char name[120];
	sprintf(name, "%s_%i.3d.t.dat", stdmeshname, filenr);
	cout << "Saving \""<< name << "\" ..." << endl;
	ofstream out;
	
	out.open(name, ios::out|ios::trunc);
	out.setf(ios::scientific);
   	
   	out << "# gnuplot conform data-file produced by "<< PROGRAM_NAME << endl;
   	out << "# Try:  gnuplot> plot \""<< name <<"\" u (1/2/3):4 w l ... \n" << endl;
   	out << "# Data:  x[m] - y[m] - t[s] - I[W/cm2] \n" << endl;
 
	for (int ix=0;ix<feld->Nr;ix++) {     
	 for (int iy=0;iy<feld->Nr;iy++) {
	 //for (int iy=int(feld->Nr /2);iy<int(feld->Nr /2)+1;iy++) {      
  		for (int jt=0;jt<feld->Ntw;jt++) {
	 		out 
	 			<< feld->radius[ix] - feld->x0 <<" "
	 			<< feld->radius[iy] - feld->y0 <<" "
	 			<< feld->time[jt]   <<" "
	 			<< feld->intensity( feld->index(ix,iy) ,jt ) <<" "
	 			<< endl; 
  		}
  		out << endl; // empty line after every t/w-slice for better data handling in gnuplot
	  }
	}
//   	for (ir=irmin;ir<irmax;ir+=dir) { 
//   		for (jt=jtmin;jt<jtmax; jt+=djt) {
// 			out << radius[ir] <<" "<< wORt[jt] <<" "<< feld[ir][jt] <<" "<< endl; 
//   		}   out << endl; // empty line after every t/w-slice for better data handling in gnuplot
//   	}
   	out.close();

return 0;
}
// ******************************************** //


// ********************************************************************************************** //
int write_3D_omega(class tArrayComplex3D_xyt *feld, char *stdmeshname, int filenr  )
{
	char name[120];
	sprintf(name, "%s_%i.3d.w.dat", stdmeshname, filenr);
	cout << "Saving \""<< name << "\" ..." << endl;
	ofstream out;
	out.open(name, ios::out|ios::trunc);
	out.setf(ios::scientific);
   	out << "# gnuplot conform data-file produced by "<< PROGRAM_NAME << endl;
   	out << "# Try:  gnuplot> plot \""<< name <<"\" u (1/2/3):4 w l ... \n" << endl;
   	out << "# Data:  x[m] - y[m] - omega[1/s] - I[W/cm2] \n" << endl;
    
	for (int ix=0;ix<feld->Nr;ix++) {     
	  //for (int iy=0;iy<feld->Nr;iy++) {
	  for (int iy=int(feld->Nr /2);iy<int(feld->Nr /2)+1;iy++) {       
  		for (int jt=0;jt<feld->Ntw;jt++) {
 
	 		out 
	 			<< feld->radius[ix] - feld->x0 <<" "
	 			<< feld->radius[iy] - feld->y0 <<" "
	 			<< feld->omega[jt]   <<" "
	 			<< feld->intensity( feld->index(ix,iy) ,jt ) <<" "
	 			<< endl; 
  		}
  		out << endl; // empty line after every t/w-slice for better data handling in gnuplot
	  }
	}
//   	for (ir=irmin;ir<irmax;ir+=dir) { 
//   		for (jt=jtmin;jt<jtmax; jt+=djt) {
// 			out << radius[ir] <<" "<< wORt[jt] <<" "<< feld[ir][jt] <<" "<< endl; 
//   		}   out << endl; // empty line after every t/w-slice for better data handling in gnuplot
//   	}
   	out.close();

return 0;
}
// ******************************************** //



