// Author: Torsten.Leitner@email.de
// (c) 2006/2007


#include <stdio.h>
#include <unistd.h> // it contains the [" int sleep(unsigned int seconds) "]-function
#include <iostream>
#include <iomanip>
#include <fstream>
#include <string>
#include <math.h>
#include <complex>
#include <vector>
#include <sstream>


/*
#include <gsl/gsl_math.h>
//#include <gsl/gsl_complex.h>
//#include <gsl/gsl_complex_math.h>
//#include <gsl/gsl_sf_bessel.h>
//#include <gsl/gsl_integration.h>
#include <gsl/gsl_const_mksa.h>
#include <gsl/gsl_math.h>
//#include <gsl/gsl_complex.h>
//#include <gsl/gsl_complex_math.h>
//#include <gsl/gsl_sf_bessel.h>
#include <gsl/gsl_errno.h>
//#include <gsl/gsl_integration.h>
#include <gsl/gsl_const_mksa.h>
#include <gsl/gsl_fft_real.h>
//#include <gsl/gsl_fft_halfcomplex.h>
#include <gsl/gsl_fft_complex.h>
*/

#include <fftw3.h>
#include "fftw_fft.h"
//#include "complexFFT.H"
//#include "gsl_fft.h"
#include "Definitions.h"
#include "tArrayComplex2D_rt.h"
//#include "singleatom.h"
#include "InitFundamentalLaser.h"
#include "GasTargetIonization.h"
#include "evolve.h"
#include "tools.h" 
#include "AnyOption.h"
#include "options.h"
#include "gnuplot.h"
#include "logbuch.h"
#include "InAndOut.h"

#include "tmptmp.h"

#include "twodee_tests.h"
#include "threedee_tests.h"

//#include <octave/octave/oct.h>

#define BEGRUESUNG "Servus, altes Haus !"


using namespace std;

// *********************************************************************************************************************
// *********************************************************************************************************************
int test_IonisationRate(struct InputParameter inpar)
{
/// 	double TIR_ADK(double E, const double Ip, const int Z)
double tir;

int Z  = inpar.ZAtom;
double Ip = inpar.Ip;

/// hard-coded Params
   Z =  Z_NEON;   // Neon
  Ip = IP_NEON;   // [eV]



double dI = 1e+10; double  I = - dI + 1e+10; double Imax = 1e18;  // SI Units   [W/cm2]

ofstream file;
file.open("/home/leitner/octave/t_ADK.He.rate", ios::out|ios::trunc);

cout << "Eau " << " Esi" <<  " Intens " << "tir" << endl;
int ttt=0;
double E;
while ( I <= Imax ) {
	ttt++;
	if (ttt%10==0) {ttt=0;dI*=10;}
	I += dI; 

//	Intensity = EPSILONZERO*CLIGHT*E*E;
	
	E = sqrt( 1e4*I/(EPSILONZERO*CLIGHT) ); // I[W/cm2] -> E[V/m]  // I[W/m] = 1e4*I[W/cm2]

//	tir = TIR_ADK( E ,  Ip ,  Z );
//	tir = TIR_fit_Ne( E );
	tir = TIR_fit_He( E );

//	tir[au] =  (1/time_SItoAU) * tir[1/s];

	cout << E * VperM_SItoAU << " " << E << " " << I << " " << tir << " " << (1/time_SItoAU) * tir << endl;
	file << E * VperM_SItoAU << " " << E << " " << I << " " << tir << " " << (1/time_SItoAU) * tir << endl;	
}



/*	
int Nr 	= inpar.Nr;
int Ntw = inpar.Ntw1;
//int Nr = inpar.Nr;
	
class tArrayComplex2D_rt Laser (inpar.Nr,inpar.rmax,inpar.Ntw1,inpar.w1max);
class tArrayComplex2D_rt  Src1 (inpar.Nr,inpar.rmax,inpar.Ntw1,inpar.w1max);

double  **ExpIntTir; // expIntegralTunnelIonRate
ExpIntTir = new double* [Nr];	        for (int i=0;i<Nr;i++) { ExpIntTir[i] = new double [Ntw]; }

double Src1Prefactor  = PREFACTOR_FUNDAMENTAL_SOURCE;//= ECHARGE*ECHARGE/(EPSILONZERO*EMASS*CLIGHT*CLIGHT)=3.5411282e-14[m]
	   Src1Prefactor *= inpar.AtomDensity;
//	   Src1Prefactor *= 1e-13;  // willkuerliche Konstante ...
//	   Src1Prefactor *= 0;

	InitFundamentalLaser_GaussianProfile_tSpace( &Laser,  &inpar );   


// ******* Calculate the fundamental source term ... Src1 ************************************************ //
//
// Src1(t) = SquarePlasmaFrequency(t) * E1(t) / c^2
// 		   =  (e^2/epsi0*me)* n0   * { 1-exp(-int_-inf^t[tir(t') dt'])} * E1(t) / c^2  
// 		   = (e^2*n0/epsi0*me*c^2) * { 1 - ExpIntTir[ir][jt] }          * E1[ir][jt] 
//		   =    Src1Prefactor      * { 1 - ExpIntTir[ir][jt] }          * E1[ir][jt];  


		Integral_TIR_AmmosovDeloneKrainov ( ExpIntTir, &Laser,  Ip, ZAtom );
		Elementwise_Exp_minus_X           ( ExpIntTir, Laser.Nr, Laser.Ntw);

    	for (int ir=0;ir<Laser.Nr;ir++) { 
    		for (int jt=0;jt<Laser.Ntw;jt++) {
//    		  Src1.data[ir][jt] =  Laser.data[ir][jt];
//            Src1.data[ir][jt] = Complex(ExpIntTir[ir][jt],0);
    		  Src1.data[ir][jt] = ( 1 - ExpIntTir[ir][jt] ) * Src1Prefactor *  Laser.data[ir][jt];
//    		  cout << ir <<" "<< jt <<" "<<Src1.data[ir][jt] << endl; 
    		}
    	}
    	Src1.fft(); //  Src1(t) --> Src1(w)
    // cout << " Src1 calculated ..." << endl;
///// ******************************  Src1(w) calculated ... *************************** //    
//
//*/
	return 0;
}
// *********************************************************************************************************************
// *********************************************************************************************************************

int do_compare_vecpot_integration_methods(struct InputParameter inpar, int Ntw, double *fft_time, double *int_time)
{
inpar.Ntw1  = Ntw;
double start,end;
cout << " Ntw = " << inpar.Ntw1 << endl;

	class tArrayComplex2D_rt  E         (inpar.Nr,inpar.rmax,inpar.Ntw1,inpar.w1max);

	class tArrayComplex2D_rt  IntA      (inpar.Nr,inpar.rmax,inpar.Ntw1,inpar.w1max);
	
	class tArrayComplex2D_rt  IntA2     (inpar.Nr,inpar.rmax,inpar.Ntw1,inpar.w1max);

	class tArrayComplex2D_rt  Afft      (inpar.Nr,inpar.rmax,inpar.Ntw1,inpar.w1max);
	class tArrayComplex2D_rt  Aint      (inpar.Nr,inpar.rmax,inpar.Ntw1,inpar.w1max);


	InitFundamentalLaser_GaussianProfile_tSpace( &E,  &inpar );	
	cout << "calculating fft ... " ;
	systime_ms(&start);
	CalcVecPotAndIntegrals_fft (&E, &Afft, &IntA, &IntA2);
	systime_ms(&end);
	*fft_time = end-start;
	cout << *fft_time << " ms" <<endl;
	cout << "calculating int ... " ;
	systime_ms(&start);
	CalcVecPotAndIntegrals_int (&E, &Aint, &IntA, &IntA2);
	systime_ms(&end);
	*int_time = end-start;
	cout << *int_time << " ms" <<endl;
	
	cout << "saving A(t) "<<endl;  
	int jtminout = 0	,	jtmaxout = inpar.Ntw1-1	,	djtout	 = 1;
	char meshname[120];	
	sprintf(meshname, "%sAt%i",inpar.outfile.c_str(),inpar.Ntw1 ); 
	write_twolines( &Afft,&Aint, 0, jtminout, jtmaxout, djtout, meshname);


   return 0;
}

int compare_vecpot_integration_methods(struct InputParameter inpar)
{
// Benchmarks fft integration against 2Pt.trapezoidal-rule :
// RESULT : fft is slower than 2Pt.int... the ratio (fft-int)/int ~ 1e-5-1e-6
//	
// Evaluation of the Benchmark with the help of "octave" gives:
//
//	time_fft    ( Ntw )[ms] =  33.3e-4 * Ntw - 357.6 ;
//	time_int2Pt ( Ntw )[ms] =   5.3e-4 * Ntw +- 0    ;
//
//		-->		int2Pt ist um    6.5*Ntw    schneller als fft  !!!! 
//
	
inpar.outfile=string("/home/leitner/data/vecpot_test/");
inpar.omega0    =  2*PI*CLIGHT/inpar.lam;

inpar.Nr    = 2;
inpar.rmax  = 1;
inpar.w1max = 200 * inpar.omega0; /// 2*omega0 gibt schoene darstellung aber zuwenig fuer Y(w), 
								  //  ...  da das Maximum bei 2*omega0 liegt ... ab 2.5*omega0 funzts ...
char benchmarkFileName[120];
sprintf(benchmarkFileName,"%sVecPotIntegrationBenchmark.dat",inpar.outfile.c_str());								  
ofstream benchmark;
benchmark.open(benchmarkFileName, ios::out|ios::trunc);
benchmark << "# gnuplot conform data-file produced by "<< PROGRAM_NAME << endl;
benchmark << "#  Ntw --- fft_time [ms] --- 2Point-Int_time [ms] " << endl;
benchmark << "# " << endl;

int Ntw = 8192;
double fft_time, int_time;
while (Ntw < 1048576) {
	Ntw *= 2;
	do_compare_vecpot_integration_methods(inpar,Ntw,&fft_time,&int_time);
	benchmark << Ntw << " " << fft_time << " " << int_time << endl;
}

benchmark.close();
   return 0;
}



/////////////////////////////////////////////////////////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////////////////////////////////////////
int test_SA(struct InputParameter inpar)
{
char text[256];	
// Laser->at(ir,jt) =  gauss2d_radial(in->E0,Laser->radius[ir],in->waist0,in->zfocus,in->lam) 
//	 						    *  gauss_tdomain (Laser->time[jt], (2*PI*CLIGHT/in->lam),in->lifetime) ;

inpar.outfile=string("/home/leitner/data/SA_test/");

//inpar.E0 	= 2e10;

inpar.waist0 	=  1;
inpar.zfocus 	=  0;
inpar.lam 		=  800e-9; //[m]
inpar.omega0    =  2*PI*CLIGHT/inpar.lam; //[Hz]
cout << "w0 "<< inpar.omega0 << endl;

//inpar.lifetime 	= 100e-15;
int	  Ntw	= inpar.Ntw1;
	  Ntw	= 8192;		
	 //2**19=524288//2**18=262144//2**17=131072//2**16=65536//2**15=32768
 	 //2**14= 16384//2**13=  8192//2**12=  4096//2**11= 2048//2**10= 1024
	  
/*//////
 Bedingungen an Punktzahl und dt:
Def.:  L := T / tau ;  --> Anz. an Lebenszeiten, die min. ins Zeitfenster passen sollen. ( L > 5 ist wuenschenswert)

a) Um Q.te Harmonische noch Darzustellen:     	dt = PI/(Q*w0)

b) Um Puls im t-Raum genuegend darzustellen:  	T >= L*tau;

				T = (N-1)*dt >= L*tau  -->	 	N >= 1 + L*tau/dt = 1 + L*Q*tau*w0/PI

>>>>>>>>  Werte Bedingung a) aus und passe dann gegebenenfalls N gemaess Bedingung b) an.	
/*//////

double Q = 200;  // Maximum sampled frequency in units of the fundamental Laser's frequency
double L  = 6 ;  // Minimum size of the Time-Window in units of the lifetime of the Laser.

double dt = PI / (Q*inpar.omega0); // = 2*PI / N*dw = PI / wNyq ;


// Check the Number of Points in time wether it's even and 
//		it's big enough to represent the whole Laser-Pulse ( ie: T > 8*tau )
int nn = int(1+L*inpar.lifetime/dt); // nn = min. Nr. of time points, related to tau 
if(  Ntw  <=  nn ) { Ntw  =  nn+1; sprintf(text,"Increased  number of points in time --> Ntw = %i",Ntw);    log::both(text); }   // Lieber 1 zuviel, als zuwenig ...
if( Ntw%2 !=   0 ) { Ntw +=  1   ; sprintf(text,"\"Evenized\" number of points in time --> Ntw = %i",Ntw); log::both(text); }
//  Even number of time-points needed for the tArrayClass ...

//if( Ntw < nn ) { Ntw = ( nn/(1+L*inpar.lifetime/dt) != 0 ? 1+nn : nn ); }
//int(x > 0.0 ? x + 0.5 : x - 0.5);



cout << "dt " << dt << "--- T/tau " << (Ntw-1)*dt/inpar.lifetime << endl;


								inpar.Ntw1     	=  Ntw; 
int   Ntwh  	= Ntw;			inpar.Ntwh		=  Ntwh;
	 //2**19=524288//2**18=262144//2**17=131072//2**16=65536//2**15=32768
 	 //2**14= 16384//2**13=  8192//2**12=  4096//2**11= 2048//2**10= 1024

double wmax = Q * inpar.omega0; /// 2*omega0 gibt schoene darstellung aber zuwenig fuer Y(w), 
								  //  ...  da das Maximum bei 2*omega0 liegt ... ab 2.5*omega0 funzts ...
						  
inpar.w1max	=  wmax;
inpar.whmax	=  wmax;

int 	Nr1  = 2; 
double rmax1 = 1;
double Ip;     Ip  = inpar.Ip;
int ZAtom;  ZAtom  = inpar.ZAtom;


//int   filenr=100;
//char *stdname="/home/leitner/data/rhyno/rhynotest";
char stdmeshname[80];
char meshname[80];
sprintf(stdmeshname, "%s", inpar.outfile.c_str()); 
ofstream meshout; cout << "Meshdata output set to \"" << stdmeshname <<"_XXX.mesh.dat\" ..."<<endl;

	int ir = 0;
	int jt = 0;
	
	
	int jtminout = 0	,	jtmaxout = Ntw-1	,	djtout	 = 1;
	
cout << "Nr1  " << Nr1 << endl;
cout << "rmax " << rmax1 << endl;
cout << "Ntw  " << Ntw << endl;
cout << "wmax " << wmax << "      wmax/w0 " << wmax/inpar.omega0 << endl;	
	

	class tArrayComplex2D_rt  Et    (Nr1,rmax1,Ntw,wmax);
	class tArrayComplex2D_rt  A     (Nr1,rmax1,Ntw,wmax);
	
	class tArrayComplex2D_rt  IntA2fft     (Nr1,rmax1,Ntw,wmax);
	class tArrayComplex2D_rt  IntA2int     (Nr1,rmax1,Ntw,wmax);
	
	class tArrayComplex2D_rt  IntA  (Nr1,rmax1,Ntw,wmax);
	class tArrayComplex2D_rt  IntA2 (Nr1,rmax1,Ntw,wmax);
	
	Complex *xt;  xt = new Complex[Ntw];
	
	class tArrayComplex2D_rt  P     (Nr1,rmax1,Ntw,wmax);
	
	InitFundamentalLaser_GaussianProfile_tSpace( &Et,  &inpar );	
	
//	for (int i=0;i<Ntw;i++){ cout << "Et : "<< Et.at(0,i) << " ln(abs(Et)) : "<< log(Et.abs(0,i))<< endl; }
	
	CalcVecPotAndIntegrals (&Et, &A, &IntA, &IntA2);
	
//	CalcVecPotAndIntegrals_fft(&Et, &A, &IntA, &IntA2fft);
//	CalcVecPotAndIntegrals_int(&Et, &A, &IntA, &IntA2int);  

//	CalcDipoleMoment(xt, &Et, &A, &IntA, &IntA2, ir, Ntw, Et.dt, Ip);
	CalcDipoleMoment(xt, &Et, &A, &IntA, &IntA2,  0, Ntw, Et.dt, inpar.omega0, Ip);

///*	
// ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
///	Kopiere (n0-ne(r,z,t))*xt in mitte von P(w) ...  vorerst ne=0; n0=1
	//for (jt=0;jt<int((Ntwh-Ntw)/2) ;jt++){	P.data[ir][jt] = 0 ; }
	for (jt=0;jt<Ntw;jt++){	
						P.data[ir][jt+int((Ntwh-Ntw)/2)] = Complex(2* xt[jt].real() , 0 );   
					//	P.data[ir][jt+int((Ntwh-Ntw)/2)] = xt[jt];   
		    }
	//for (jt=int((Ntwh-Ntw)/2)+Ntw;jt<Ntwh ;jt++){	P.data[ir][jt] = 0 ; }
// ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
//*/



///*
	//// save E(t) -2
	jtminout = 0	;	jtmaxout = Ntw-1	;	djtout	 = 1;
	sprintf(meshname, "%sEt",stdmeshname ); 
	write_linedat(&Et , 0 , jtminout,jtmaxout,djtout,meshname);    
	//// save P(t) -2
	jtminout = 0	;	jtmaxout = Ntwh-1	;	djtout	 = 1;
	sprintf(meshname, "%sPt",stdmeshname );	
	write_linedat(&P , 0 , jtminout,jtmaxout,djtout,meshname);     
	
	//// save P(w) -3
	P.fft();
	jtminout = 0	;	jtmaxout = int((Ntwh-1))	;	djtout	 = 1;
	sprintf(meshname, "%sPw",stdmeshname );
	write_linedat_omega(&P , 0, jtminout,jtmaxout,djtout,meshname,inpar.omega0);      
//*/

/*
//// save A(t) 
	jtminout = 0	;	jtmaxout = Ntw-1	;	djtout	 = 1;
	sprintf(meshname, "%sIntA2t",stdmeshname ); 
	write_twolines( &IntA2fft,&IntA2int, 0, jtminout, jtmaxout, djtout, meshname);
//*/	
	return 0;
}
// *********************************************************************************************************************
// *********************************************************************************************************************
int tirtest(struct InputParameter inpar)
{
char text[256];
inpar.outfile=string("/home/leitner/data/rhyno/tirtest");

/*   //from GOLUM ... artificial but working properly ...
inpar.Nr    	= 300;
inpar.dr       	= 1e-5;
inpar.waist0   	= (inpar.Nr/10)*inpar.dr;
inpar.lifetime  = 7e-17;
inpar.lam     	= inpar.dr*1e-3;
inpar.omega0    = 2*PI*CLIGHT/inpar.lam;
inpar.dz        = inpar.dr*1e-5;
inpar.Ntw     	=  128;  //2**19=524288 // 2**18=262144 // 2**17=131072 // 2**16=65536 // 2**15=32768
		   			     //2**14= 16384 // 2**13=  8192 // 2**12=  4096 // 2**11= 2048 // 2**10= 1024
//*/////

///*   //mine
//inpar.Nr    	=  300;									// in StdParams
//inpar.lam     	=  740e-9;							// in StdParams
//inpar.dr       	=  1e3 * inpar.lam;					// in StdParams	
//inpar.dr		=  inpar.waist0 * 10 / inpar.Nr ;		// in StdParams
//inpar.waist0   	=  (inpar.Nr/10)*inpar.dr;			// in StdParams

//inpar.lifetime  = 15e-15;
inpar.omega0    =  2*PI*CLIGHT/inpar.lam;
//inpar.dz        =  1e2 * inpar.lam;					// in StdParams
//inpar.dz        =  1e1 * inpar.dr;						// in StdParams
inpar.Ntw1     	=  inpar.Ntw;  //2**19=524288//2**18=262144//2**17=131072//2**16=65536//2**15=32768
			 			 //2**14= 16384//2**13=  8192//2**12=  4096//2**11= 2048//2**10= 1024
//*/////

// muss noch in SetStandardInputParameters(...);
inpar.w1max	= 2.5 * inpar.omega0; /// 2*omega gibt schoene darstellung aber zuwenig fuer Y(w), 
								  //  ...  da das Maximum bei 2*omega0 liegt ... ab 2.5*omega0 funzts ...
inpar.rmax	= (inpar.Nr-1)*inpar.dr;


/*  // original RHYNO parameters
int    Nr 	= 30;
double E0       =1.0;
double xlam     = 800e-9; 		//[m]
double omega0   = 2*PI*CLIGHT/xlam;  	//[rad/s]
double  dr      = xlam*1e3;	//[m]
double  dz      =  dr*1e-5;	//[m]
double  waist0  = (Nr-1)*dr / 1;//[m]
double  zfocus  = 0;// *dr;  	// relative to capillary
//*/

//inpar.lifetime = 10e-15;
//int 	nruns  	  = inpar.nruns;
//int 	nsteps 	  = inpar.nsteps;

int	    Ntw	  	  = inpar.Ntw;

//inpar.Nr = 2 ;

double  dz	      = inpar.dz; dz= inpar.dz;
int	    Nr  	  = inpar.Nr;
double  Omegamax 	  = inpar.w1max;
double  Rmax      = inpar.rmax;

inpar.Ip    =   IP_HYDROGEN;  // [eV] 
inpar.ZAtom =    Z_HYDROGEN; // 1

double Ip; Ip	  = inpar.Ip;
int ZAtom; ZAtom  = inpar.ZAtom;


inpar.w1max	=  Omegamax;
inpar.whmax	=  Omegamax;

int   	filenr=101;
int		filenrLaser=filenr;

//char *stdname="/home/leitner/data/rhyno/rhynotest";
char stdmeshname[80];
sprintf(stdmeshname, "%s_%ifs", inpar.outfile.c_str() , int(0.1 + inpar.lifetime*1e15) ); 
//ofstream meshout; 
cout << "Output set to \"" << stdmeshname <<"_XXX.xxx.dat\" ..."<<endl;



class tArrayComplex2D_rt 	Laser    (Nr,Rmax,Ntw,Omegamax);
class tArrayComplex2D_rt 	Src1     (Nr,Rmax,Ntw,Omegamax);
	
//class tArrayComplex2D_rt    Harm     (Nr,Rmax,Ntw,Omegamax);
//class tArrayComplex2D_rt    P 	 	 (Nr,Rmax,Ntw,Omegamax);
////class tArrayComplex2D_rt    SrcH 	 (Nr,Rmax,Ntw,Omegamax);		
//
//class tArrayComplex2D_rt  	A    	 (Nr,Rmax,Ntw,Omegamax);
//class tArrayComplex2D_rt  	IntA  	 (Nr,Rmax,Ntw,Omegamax);
//class tArrayComplex2D_rt  	IntA2 	 (Nr,Rmax,Ntw,Omegamax);
//
//Complex *xt;  xt = new Complex[Ntw];



//class tArrayComplex2D_rt 	Harmonics(Nr,Rmax,Ntw,Omegahmax);


// evtl. copy-constructor verwenden ... Src1=Laser;
//	--> Gleiche Grid-Parameter trivial gesichert ...	

double  **ExpIntTir; // expIntegralTunnelIonRate
ExpIntTir = new double* [Nr];	        for (int i=0;i<Nr;i++) { ExpIntTir[i] = new double [Ntw]; }


int dirout   = 1;
int irminout = 0;
int irmaxout = int(Nr/2);
int djtout   = 1;
////int jtminout  = int(Ntw/8);int jtmaxout  = Ntw - jtminout;
////int jtminout  = int(Ntw/4); int jtmaxout  = Ntw - jtminout;
int jtminout  = 0; int jtmaxout  = Ntw - 1;

 //*
log::screen("");
log::screen(LOG_SEPARATOR_STARS);
log::screen(""); 
sprintf(text,"Rmax   	= %g [m]    	  = %g  * waist0       ",inpar.rmax,inpar.rmax/inpar.waist0 );  log::both(text);
sprintf(text,"zfocus 	= %g [m] | waist0 = %g [m]             ",inpar.zfocus,inpar.waist0 );			log::both(text);
sprintf(text,"w1min/max = (+/-) %g [Hz]   = (+/-) %g  * omega0 ",Laser.wmax,Laser.wmax/inpar.omega0 );	log::both(text);
sprintf(text,"t1min/max = (+/-) %g [s]    = (+/-) %g * lifetime",Laser.tmax,Laser.tmax/inpar.lifetime );log::both(text);
																										log::both("");
sprintf(text,"Atomdensity n0        = %g [1/m3] = 1e-6[1/cm3]       ",inpar.AtomDensity );				log::both(text);
sprintf(text,"Gas temperature       = %g [Kelvin]                   ",inpar.Temperature );				log::both(text);
sprintf(text,"Gas pressure          = %g [mbar]                     ",inpar.Pressure    );				log::both(text);
sprintf(text,"Max. Intensity        = %g [W/cm2]                    ",inpar.Intensity   );				log::both(text);
sprintf(text,"E0 - Max.Ampl.        = %g [V/m]                      ",inpar.E0          );				log::both(text);
sprintf(text,"Fund. wavelength  lam = %g [m]            ",inpar.lam);									log::both(text);
sprintf(text,"Fund. frequency   w0  = %g [Hz]           ",inpar.omega0);								log::both(text);
																										log::both("");
sprintf(text,"Propagation Step         dz = %g [m] = %g * lam ",inpar.dz,inpar.dz/inpar.lam);			log::both(text);
sprintf(text,"Radial grid width        dr = %g [m] = %g * lam ",inpar.dr,inpar.dr/inpar.lam);			log::both(text);
sprintf(text,"Number of spatial points           Nr= %i       ",inpar.Nr);                   			log::both(text);
log::both("");
sprintf(text,"Number of points in time          Ntw= %i       ",Ntw);                   				log::both(text);
log::both(LOG_SEPARATOR_STARS);
sprintf(text,"nPics  : % 4i",inpar.nPics); 	log::both(text);
sprintf(text,"nruns  : % 4i",inpar.nruns 		); 	log::both(text);
sprintf(text,"nsteps : % 4i",inpar.nsteps 	); 	log::both(text);
log::both(LOG_SEPARATOR_STARS);
log::both("");
// */
//% ***************************************************************************
//% ***************************************************************************

double Src1Prefactor  = PREFACTOR_FUNDAMENTAL_SOURCE;//= ECHARGE*ECHARGE/(EPSILONZERO*EMASS*CLIGHT*CLIGHT)=3.5411282e-14[m]
	   Src1Prefactor *= inpar.AtomDensity;
//	   Src1Prefactor *= 1e-13;  // willkuerliche Konstante ...
//	   Src1Prefactor *= 0;
cout << " Src1Prefactor = " << Src1Prefactor << endl;
// ******************************************************************************************************* //
// ************ Main loop evolve nruns*nsteps; drop data after every run ... ***************************** //
// ******************************************************************************************************* //

cout << " Start evolve ... " << endl;



InitFundamentalLaser_GaussianProfile_tSpace( &Laser,  &inpar );   

//*
// Write LASER
sprintf(text, "%s_Laser",  stdmeshname ); 
write_time_2d(&Laser, irminout,irmaxout,dirout, jtminout,jtmaxout,djtout,text,0);
//  write_meshdat_time(&Laser, 0       ,Nr-1    ,10    , 0       ,Ntw-1   ,100   ,text,0);

/// begin Sources
		double IntTir=0; 			
//  Calc exp[-int(tir)] ...   R(t) in der Dipl.Arbeit
			//	tir = TIR_fit_Ne( E );				//	tir = TIR_fit_He( E );
		for (int ir=0;ir<Nr;ir++)	{	
			IntTir = 0;  //  new spatial position  r_i -> IntTir = 0
			ExpIntTir[ir][0] = 1; // IntTir[ir][0] = 0  ->  exp(0) = 1;
			for (int jt=1;jt<Ntw;jt++)	{ //start from 1 ...
				IntTir += Laser.dt * 0.5 * ( TIR_fit_Ne( Laser.real(ir,jt-1) ) + TIR_fit_Ne( Laser.real(ir,jt) ) );     
					// berechnet log(R(t)) = \int_{-infty}^{t} w(t') dt'
				ExpIntTir[ir][jt] = exp( - IntTir  );	         // berechnet     R(t)  = \exp\[ \int_{-infty}^{t} w(t') dt' \]
//				ExpIntTir[ir][jt] = IntTir;
//				ExpIntTir[ir][jt] = TIR_fit_Ne( Laser.real(ir,jt) );
			}
		}
// ExpIntTir done for all  ir,jt ... and this z

// ******* Calculate the fundamental source term ... Src1 ************************************************ //
//
// Src1(t) = SquarePlasmaFrequency(t) * E1(t) / c^2
// 		   =  (e^2/epsi0*me)* n0   * { 1-exp(-int_-inf^t[tir(t') dt'])} * E1(t) / c^2  
// 		   = (e^2*n0/epsi0*me*c^2) * { 1 - ExpIntTir[ir][jt] }          * E1[ir][jt] 
//		   =    Src1Prefactor      * { 1 - ExpIntTir[ir][jt] }          * E1[ir][jt];  

    	for (int ir=0;ir<Laser.Nr;ir++) { 
    		for (int jt=0;jt<Laser.Ntw;jt++) {
//    		  Src1.data[ir][jt] =  Laser.data[ir][jt];
//            Src1.data[ir][jt] = Complex(ExpIntTir[ir][jt],0);
              Src1.data[ir][jt] = Complex(0,0);
//    		  Src1.data[ir][jt] = Src1Prefactor * ( 1 - ExpIntTir[ir][jt] ) * Laser.data[ir][jt];
//    		  cout << ir <<" "<< jt <<" "<<Src1.data[ir][jt] << endl; 
    		}
    	}
    // cout << " Src1 calculated ..." << endl;
///// ******************************  Src1(w) calculated ... *************************** //    
//

evolve2d( 10, dz, &Laser, &Src1);   		    //% Evolve nsteps fundamental ...

// Write LASER
sprintf(text, "%s_Laser",  stdmeshname ); 
write_time_2d(&Laser, irminout,irmaxout,dirout, jtminout,jtmaxout,djtout,text,filenrLaser);      

// Write Src1
sprintf(text, "%s_Src1",  stdmeshname ); 
write_time_2d(&Src1, irminout,irmaxout,dirout, jtminout,jtmaxout,djtout,text,filenrLaser);     
filenrLaser++;

return 0;
}


// *********************************************************************************************************************
// *********************************************************************************************************************
// *********************************************************************************************************************
// *********************************************************************************************************************
// *********************************************************************************************************************
// *********************************************************************************************************************
int the_program(struct InputParameter inpar)
{
char text[256];
inpar.outfile=string("/home/leitner/data/rhyno/test_SrcH_values");

/*   //from GOLUM ... artificial but working properly ...
inpar.Nr    	= 300;
inpar.dr       	= 1e-5;
inpar.waist0   	= (inpar.Nr/10)*inpar.dr;
inpar.lifetime  = 7e-17;
inpar.lam     	= inpar.dr*1e-3;
inpar.omega0    = 2*PI*CLIGHT/inpar.lam;
inpar.dz        = inpar.dr*1e-5;
inpar.Ntw     	=  128;  //2**19=524288 // 2**18=262144 // 2**17=131072 // 2**16=65536 // 2**15=32768
		   			     //2**14= 16384 // 2**13=  8192 // 2**12=  4096 // 2**11= 2048 // 2**10= 1024
//*/////

///*   //mine
//inpar.Nr    	=  300;									// in StdParams
//inpar.lam     	=  740e-9;							// in StdParams
//inpar.dr       	=  1e3 * inpar.lam;					// in StdParams	
//inpar.dr		=  inpar.waist0 * 10 / inpar.Nr ;		// in StdParams
//inpar.waist0   	=  (inpar.Nr/10)*inpar.dr;			// in StdParams

//inpar.lifetime  = 15e-15;
inpar.omega0    =  2*PI*CLIGHT/inpar.lam;
//inpar.dz        =  1e2 * inpar.lam;					// in StdParams
//inpar.dz        =  1e1 * inpar.dr;						// in StdParams
inpar.Ntw1     	=  inpar.Ntw;  //2**19=524288//2**18=262144//2**17=131072//2**16=65536//2**15=32768
			 			 //2**14= 16384//2**13=  8192//2**12=  4096//2**11= 2048//2**10= 1024
//*/////

// muss noch in SetStandardInputParameters(...);
inpar.w1max	= 2.5 * inpar.omega0; /// 2*omega gibt schoene darstellung aber zuwenig fuer Y(w), 
								  //  ...  da das Maximum bei 2*omega0 liegt ... ab 2.5*omega0 funzts ...
inpar.rmax	= (inpar.Nr-1)*inpar.dr;


/*  // original RHYNO parameters
int    Nr 	= 30;
double E0       =1.0;
double xlam     = 800e-9; 		//[m]
double omega0   = 2*PI*CLIGHT/xlam;  	//[rad/s]
double  dr      = xlam*1e3;	//[m]
double  dz      =  dr*1e-5;	//[m]
double  waist0  = (Nr-1)*dr / 1;//[m]
double  zfocus  = 0;// *dr;  	// relative to capillary
//*/

//inpar.lifetime = 10e-15;
//int 	nruns  	  = inpar.nruns;
//int 	nsteps 	  = inpar.nsteps;

int	    Ntw	  	  = inpar.Ntw;

//inpar.Nr = 2 ;

double  dz	      = inpar.dz; dz= inpar.dz;
int	    Nr  	  = inpar.Nr;
double  Omegamax 	  = inpar.w1max;
double  Rmax      = inpar.rmax;

inpar.Ip    =   IP_NEON; // [eV] 
inpar.ZAtom =    Z_NEON; // 1

double Ip; Ip	  = inpar.Ip;
int ZAtom; ZAtom  = inpar.ZAtom;


/*//////
 Bedingungen an Punktzahl und dt:
Def.:  L := T / tau ;  --> Anz. an Lebenszeiten, die min. ins Zeitfenster passen sollen. ( L > 5 ist wuenschenswert)

a) Um Q.te Harmonische noch Darzustellen:     	dt = PI/(Q*w0)

b) Um Puls im t-Raum genuegend darzustellen:  	T >= L*tau;

				T = (N-1)*dt >= L*tau  -->	 	N >= 1 + L*tau/dt = 1 + L*Q*tau*w0/PI

>>>>>>>>  Werte Bedingung a) aus und passe dann gegebenenfalls N gemaess Bedingung b) an.	
/*//////

double Q = 150;  // Maximum sampled frequency in units of the fundamental Laser's frequency
double L  = 4 ;  // Minimum size of the Time-Window in units of the lifetime of the Laser.

double dt = PI / (Q*inpar.omega0); // = 2*PI / N*dw = PI / wNyq ;


// Check the Number of Points in time wether it's even and 
//		it's big enough to represent the whole Laser-Pulse ( ie: T > 8*tau )
int nn = int(1+L*inpar.lifetime/dt); // nn = min. Nr. of time points, related to tau 
if(  Ntw  <=  nn ) { Ntw  =  nn+1; sprintf(text,"Increased  number of points in time --> Ntw = %i",Ntw);    log::both(text); }   // Lieber 1 zuviel, als zuwenig ...
if( Ntw%2 !=   0 ) { Ntw +=  1   ; sprintf(text,"\"Evenized\" number of points in time --> Ntw = %i",Ntw); log::both(text); }
//  Even number of time-points needed for the tArrayClass ...
Omegamax = Q * inpar.omega0; /// 2*omega0 gibt schoene darstellung aber zuwenig fuer Y(w), 
								  //  ...  da das Maximum bei 2*omega0 liegt ... ab 2.5*omega0 funzts ...
inpar.w1max	=  Omegamax;
inpar.whmax	=  Omegamax;

int   	filenr=101;
int		filenrLaser=filenr;
int		filenrHarm =filenr;
//char *stdname="/home/leitner/data/rhyno/rhynotest";
char stdmeshname[80];
sprintf(stdmeshname, "%s_%ifs", inpar.outfile.c_str() , int(0.1 + inpar.lifetime*1e15) ); 
//ofstream meshout; 

class tArrayComplex2D_rt 	Laser    (Nr,Rmax,Ntw,Omegamax);
class tArrayComplex2D_rt 	Src1     (Nr,Rmax,Ntw,Omegamax);
	
class tArrayComplex2D_rt    Harm     (Nr,Rmax,Ntw,Omegamax);
class tArrayComplex2D_rt    P 	 	 (Nr,Rmax,Ntw,Omegamax);
//class tArrayComplex2D_rt    SrcH 	 (Nr,Rmax,Ntw,Omegamax);		

class tArrayComplex2D_rt  	A    	 (Nr,Rmax,Ntw,Omegamax);
class tArrayComplex2D_rt  	IntA  	 (Nr,Rmax,Ntw,Omegamax);
class tArrayComplex2D_rt  	IntA2 	 (Nr,Rmax,Ntw,Omegamax);

Complex *xt;  xt = new Complex[Ntw];



//class tArrayComplex2D_rt 	Harmonics(Nr,Rmax,Ntw,Omegahmax);


// evtl. copy-constructor verwenden ... Src1=Laser;
//	--> Gleiche Grid-Parameter trivial gesichert ...	

double  **ExpIntTir; // expIntegralTunnelIonRate  R(t) = int(exp(-tir(t))
ExpIntTir = new double* [Nr];	        for (int i=0;i<Nr;i++) { ExpIntTir[i] = new double [Ntw]; }


int dirout   = 1;
int irminout = 0;
int irmaxout = Nr-1 -int(Nr/4) ; // 3/4 von r werden ausgegeben
int djtout   = 1;
////int jtminout  = int(Ntw/8);int jtmaxout  = Ntw - jtminout;
////int jtminout  = int(Ntw/4); int jtmaxout  = Ntw - jtminout;
int jtminout  = 0; int jtmaxout  = Ntw - 1;

 //*
log::screen("");
log::screen(LOG_SEPARATOR_STARS);
log::screen("");

sprintf(text,"Output set to \"%s_XXX.xxx.dat\" ",stdmeshname );  										log::both(text);
sprintf(text,"dt %g --- T/tau %g", dt , (Ntw-1)*dt/inpar.lifetime);  									log::both(text);
																										log::both(""); 
sprintf(text,"Rmax   	= %g [m]    	  = %g  * waist0       ",inpar.rmax,inpar.rmax/inpar.waist0 );  log::both(text);
sprintf(text,"zfocus 	= %g [m] | waist0 = %g [m]             ",inpar.zfocus,inpar.waist0 );			log::both(text);
sprintf(text,"w1min/max = (+/-) %g [Hz]   = (+/-) %g  * omega0 ",Laser.wmax,Laser.wmax/inpar.omega0 );	log::both(text);
sprintf(text,"t1min/max = (+/-) %g [s]    = (+/-) %g * lifetime",Laser.tmax,Laser.tmax/inpar.lifetime );log::both(text);
																										log::both("");
sprintf(text,"Atomdensity n0        = %g [1/m3] = %g[1/cm3]",inpar.AtomDensity,1e-6*inpar.AtomDensity );log::both(text);
sprintf(text,"Gas temperature       = %g [Kelvin]                   ",inpar.Temperature );				log::both(text);
sprintf(text,"Gas pressure          = %g [mbar]                     ",inpar.Pressure    );				log::both(text);
sprintf(text,"Max. Intensity        = %g [W/cm2]                    ",inpar.Intensity   );				log::both(text);
sprintf(text,"E0 - Max.Ampl.        = %g [V/m]                      ",inpar.E0          );				log::both(text);
sprintf(text,"Fund. wavelength      = %g [m]            ",inpar.lam);									log::both(text);
sprintf(text,"Fund. frequency   w0  = %g [Hz]           ",inpar.omega0);								log::both(text);
																										log::both("");
sprintf(text,"Pond. Potential   Up  = %g [J]            ",inpar.Up);  									log::both(text);
sprintf(text,"Cut off:         qcut = %g                ",inpar.qcut);								    log::both(text);
																										log::both("");									
sprintf(text,"Propagation Step         dz = %g [m] = %g * lam ",inpar.dz,inpar.dz/inpar.lam);			log::both(text);
sprintf(text,"Radial grid width        dr = %g [m] = %g * lam ",inpar.dr,inpar.dr/inpar.lam);			log::both(text);
sprintf(text,"Number of spatial points           Nr= %i       ",inpar.Nr);                   			log::both(text);
log::both("");
sprintf(text,"Number of points in time          Ntw= %i       ",Ntw);                   				log::both(text);
log::both(LOG_SEPARATOR_STARS);
sprintf(text,"nPics  : % 4i",inpar.nPics); 	log::both(text);
sprintf(text,"nruns  : % 4i",inpar.nruns 		); 	log::both(text);
sprintf(text,"nsteps : % 4i",inpar.nsteps 	); 	log::both(text);
log::both(LOG_SEPARATOR_STARS);
log::both("");
// */
//% ***************************************************************************
//% ***************************************************************************

//double Src1Prefactor  = PREFACTOR_FUNDAMENTAL_SOURCE;//= ECHARGE*ECHARGE/(EPSILONZERO*EMASS*CLIGHT*CLIGHT)=3.5411282e-14[m]
double Src1Prefactor  = ECHARGE*ECHARGE/(EPSILONZERO*EMASS*CLIGHT*CLIGHT);//=3.5411282e-14[m]
	   Src1Prefactor *= inpar.AtomDensity;
//	   Src1Prefactor *= 1e-13;  // willkuerliche Konstante ...
//	   Src1Prefactor *= 0;

// ******************************************************************************************************* //
// ************ Main loop evolve nruns*nsteps; drop data after every run ... ***************************** //
// ******************************************************************************************************* //

cout << " Start evolve ... " << endl;

double threshold = MININTENSITY_TO_CALC_DIP; // [W/cm2]
double TotalPropagationLength = 0;

InitFundamentalLaser_GaussianProfile_tSpace( &Laser,  &inpar );   

//for (int ii=0; ii<Laser.Nr; ii++ ) { 
//	cout << setw(5) << ii << " " 
//		 << TestLaserBigEnoughForDipoleMoment(&Laser, ii) 
//		 //<< Laser.intensity(20,ii)
//		 << endl;
//}	

//	%[flags][width][.precision][length]specifier  --- eg.: %03.3hi
//	sprintf(text,"Pic  % 3i ...",np);
//	log::both( text );		

//*
// Write LASER
sprintf(text, "%s_Laser",  stdmeshname ); 
write_time_2d(&Laser, irminout,irmaxout,dirout, jtminout,jtmaxout,djtout,text,0);
//  write_meshdat_time(&Laser, 0       ,Nr-1    ,10    , 0       ,Ntw-1   ,100   ,text,0);

for (int np=1;np<1+inpar.nPics;np++) {
	
	
	for (int nr=1;nr<1+inpar.nruns;nr++) {
		sprintf(text,"Pic  % 3i  Run % 3i ... % 4i steps ...",np,nr,inpar.nsteps);
		log::both( text );		

/// begin Sources
		double IntTir=0; 			

//  Calc exp[-int(tir)] ...   R(t) in der Dipl.Arbeit
			//	tir = TIR_fit_Ne( E );				//	tir = TIR_fit_He( E );
		for (int ir=0;ir<Nr;ir++)	{	
			IntTir = 0;  //  new spatial position  r_i -> IntTir = 0
			ExpIntTir[ir][0] = 1; // IntTir[ir][0] = 0  ->  exp(0) = 1;
			for (int jt=1;jt<Ntw;jt++)	{ //start from 1 ...
				IntTir += Laser.dt * 0.5 * ( TIR_fit_Ne( Laser.real(ir,jt-1) ) + TIR_fit_Ne( Laser.real(ir,jt) ) );     
					// berechnet log(R(t)) = \int_{-infty}^{t} w(t') dt'
				ExpIntTir[ir][jt] = exp( - IntTir  );	         // berechnet     R(t)  = \exp\[ \int_{-infty}^{t} w(t') dt' \]
			}
		}
// ExpIntTir done for all  ir,jt ... and this z

//
//   begin NL-SOURCE
	CalcVecPotAndIntegrals (&Laser, &A, &IntA, &IntA2);	
	
	
	for (int ir=0;ir<Nr;ir++) {		
	
	//CalcDipoleMoment for one ir only ...
	
		if ( TestLaserBigEnoughForDipoleMoment(&Laser, ir, threshold) ) 
		{
			CalcDipoleMoment(xt, &Laser, &A, &IntA, &IntA2,  ir , Ntw, Laser.dt, inpar.omega0, Ip);	
	
	//	Kopiere:  P(r,z,t) = (n0-ne(r,z,t))*d_nl(r,z,t) .... P(t)={n0-n0*[1-R(t)]}*{R(t)*x(t)}=n0 * R(t)^2 * 2*Re{x(t)} 
			for (int jt=0;jt<Ntw;jt++){	
				P.data[ir][jt] = Complex(inpar.AtomDensity * ExpIntTir[ir][jt]*ExpIntTir[ir][jt] * 2*xt[jt].real(), 0 );   		   
			}
		}
		else {
			cout << "Laser Intensity to low at  ir = " << ir << endl; 
			for (int jt=0;jt<Ntw;jt++){	
				P.data[ir][jt] = Complex( 0 , 0 );   		   
			}
		}
	}  // end for ir , Nr1
//	end NL-SOURCE::Polarisation


// ******* Calculate the fundamental source term ... Src1 ************************************************ //
//
// Src1(t) = SquarePlasmaFrequency(t) * E1(t) / c^2
// 		   =  (e^2/epsi0*me)* n0   * { 1-exp(-int_-inf^t[tir(t') dt'])} * E1(t) / c^2  
// 		   = (e^2*n0/epsi0*me*c^2) * { 1 - ExpIntTir[ir][jt] }          * E1[ir][jt] 
//		   =    Src1Prefactor      * { 1 - ExpIntTir[ir][jt] }          * E1[ir][jt];  

    	for (int ir=0;ir<Laser.Nr;ir++) { 
    		for (int jt=0;jt<Laser.Ntw;jt++) {
//    		  Src1.data[ir][jt] =  Laser.data[ir][jt];
//            Src1.data[ir][jt] = Complex(ExpIntTir[ir][jt],0);
    		  Src1.data[ir][jt] = Src1Prefactor * ( 1 - ExpIntTir[ir][jt] ) * Laser.data[ir][jt];
//    		  cout << ir <<" "<< jt <<" "<<Src1.data[ir][jt] << endl; 
    		}
    	}
    // cout << " Src1 calculated ..." << endl;
///// ******************************  Src1(w) calculated ... *************************** //    
//



	Laser.fft();	// E(t)    --> E(w)
	Src1.fft();     // Src1(t) --> Src1(w)
	P.fft();		// P(t)    --> P(w)
	// Multiply P(w) to act as NL-Source: SrcH = -mue0 * w^2 * P(w); 
	for (int ir=0;ir<Nr;ir++){for (int jt=0;jt<Ntw;jt++){  P.data[ir][jt] *= -MUEZERO * P.omega[jt]*P.omega[jt] ; }}
	//
	// EVOLVE everything for nsteps*dz without new calculation of the Sources ...
	evolve2d( inpar.nsteps, dz, &Laser, &Src1);   		    //% Evolve nsteps fundamental ...
	evolve2d( inpar.nsteps, dz, &Harm , &P   );   		    //% Evolve nsteps harmonics ...
	TotalPropagationLength += inpar.nsteps * dz ;
	//
	Laser.ifft();	// E(w) --> E(t)
	// P and Src1 will be overwritten by their new calculations ...   Harm is only needed in w-space ...
//
	} // end nruns
cout << " ***************************** " << endl;
cout << "Saving Data after "<< TotalPropagationLength << " [m] ..." << endl;

// Write LASER
sprintf(text, "%s_Laser",  stdmeshname ); 
write_time_2d(&Laser, irminout,irmaxout,dirout, jtminout,jtmaxout,djtout,text,filenrLaser);      
// Write Src1
sprintf(text, "%s_Src1",  stdmeshname ); 
write_time_2d(&Src1, irminout,irmaxout,dirout, jtminout,jtmaxout,djtout,text,filenrLaser);     
filenrLaser++;

// Write Harmonix
Harm.ifft();	// Harm(w) --> Harm(t)
sprintf(text, "%s_Harm" ,  stdmeshname );
write_time_2d(&Harm,  irminout,irmaxout,dirout, jtminout,jtmaxout,djtout,text,filenrHarm);       
Harm.fft();		// Harm(t) --> Harm(w) 
// write_meshdat_omega(&Harm,  irminout,irmaxout,dirout, jtminout,jtmaxout,djtout,text,filenrHarm);
write_omegaOverOmega0_2d(&Harm, inpar.omega0, irminout,irmaxout,dirout, jtminout,jtmaxout,djtout,text,filenrHarm);              
SaveHarmonicSpectrum_spatiallyIntegrated(&Harm,stdmeshname,inpar.omega0,filenrHarm); 
filenrHarm++; 
cout << " ***************************** " << endl;
} // end npics
// */

sprintf(text,"\n *** hhg simulation done *** \n" ); 												log::screen(text);
sprintf(text,"I did %i Cranck-Nicholson Propagation steps.",int(TotalPropagationLength / dz) 	); 	log::both(text);
sprintf(text,"-> Total Propagation Length: %10.8g [m] ...",TotalPropagationLength	); 					log::both(text);
//cout << "\n *** hhg simulation done *** \n" << endl;
//cout << "I did "<< TotalPropagationLength / dz << " Cranck-Nicholson Propagation steps." << endl;
//cout << "-> Total Propagation Length: "<< TotalPropagationLength << " [m] ..." << endl;
return 0;
}
// *********************************************************************************************************************
// *********************************************************************************************************************
// *********************************************************************************************************************
// *********************************************************************************************************************

// *********************************************************************************************************************
// *********************************************************************************************************************
int main(int argc, char **argv)
{
// *****************************************************************************	
///*     ***  Standard Program  ***
// *****************************************************************************
	
	static const class log blog;
//	static       class log blog;
	
//	log::screen("Hallo Main");
//	log::file  ("Hallo Main");
//	log::both  ("Hallo Main");

//	blog.screen("Hallo Main");
	
	cout <<"\n"<< BEGRUESUNG << "\n" << endl;
	
	struct InputParameter inpar; // struct def. : see "options.h" 
	
	SetStandardInputParameters(&inpar); // see "options.cpp" 
	
	int opterror = handle_all_options(argc,argv,&inpar); // see "options.cpp" 
	cout << "\n" << endl;
	
//
//cout << action_AUtoSI<<"action_AUtoSI "
//<< action_SItoAU <<"action_SItoAU "<< energy_AUtoSI<<"energy_AUtoSI "<<energy_SItoAU<<"energy_SItoAU "
//<< energy_AUtoeV <<"energy_AUtoeV "<<energy_eVtoAU <<"energy_eVtoAU "<<  VperM_AUtoSI<<"VperM_AUtoSI "
//<< VperM_SItoAU <<"VperM_SItoAU "<<time_SItoAU <<"time_SItoAU "<<momentum_AUtoSI <<"momentum_AUtoSI "
//<< momentum_SItoAU <<"momentum_SItoAU "
//<< electric_dipole_moment_AUtoSI<<"electric_dipole_moment_AUtoSI "
//<< electric_dipole_moment_SItoAU << "electric_dipole_moment_SItoAU"	<< endl;


	if (opterror == 0) {//cout<< "No OptError !!!"<<endl;
					    //test_SA(inpar); 
					    //the_program(inpar)	;	
					    //tirtest(inpar);	
					    // compare_vecpot_integration_methods(inpar);
					    // test_IonisationRate(inpar)	;
					    the_twodee_test_program(inpar);
					    // the_threedee_program(inpar); 					      
					   }	
	if (opterror == 2) {cout<< "Bad cmdline-option (see above) ...     Execution canceled. " << endl;}
	if (opterror == 3) {cout<< "Bad file-option (see above) ...        Execution canceled. " << endl;}
	cout << "\n" << endl;

// *****************************************************************************

	return 0;
}
// *****************************************************************************
// *****************************************************************************


 /* // Static log test

	class log blog;
	
	log::Message("Hallo Main");


// */

/*   Plotting png with gnuplot ...
	int logscale=0;
	int terminaltype=1;
	char *xlabel="r";
	char *ylabel="Intensity";
	char *title ="|E(r)|^2";
	char *style="points";
	char *filename="/home/goofy/data/rhyno-tests-2007-04-02";    
	double delay=1;
	double y[Nr];
	double x[Nr];
	
	filenr++;
	for (ir=0; ir<Nr; ir++){ y[ir]=abs(E1[ir][jt])*abs(E1[ir][jt]); 
				 x[ir]=radius[ir];
				 cout << x[ir] << " " << y[ir] << endl;	}
	gplotplotxy( Nr , x , y,  delay,logscale ,terminaltype,   
		     xlabel , ylabel, title , style ,filename, filenr);

	// Output of the fourier transforms of the tLaser and the wLaser
	ofstream wffile("post.dat", ios::out|ios::trunc);       // -fmax  mitte      
	for(jt=0;jt<Nt;jt++) {
// */  

