// Author: Torsten.Leitner@email.de
// (c) 2006/2007


#include "tArrayComplex3D_xyt.h"


using namespace std;
// CONSTRUKTORs	
tArrayComplex3D_xyt:: tArrayComplex3D_xyt()
{
	Nr	= 0;
	Ntw	= 0;
	dr  = 0;
	rmax= 0;
	rmin= 0;
	dw  = 0;
	wmax= 0;
	wmin= 0;
	dt  = 0;
	tmax= 0;
	tmin= 0;

}

tArrayComplex3D_xyt:: tArrayComplex3D_xyt(int inNr, int inNtw)
{
	init(inNr,inNtw);
}

tArrayComplex3D_xyt:: tArrayComplex3D_xyt(int inNr, double inRmax, int inNtw, double inWmax)
{
	init(inNr,inRmax,inNtw,inWmax);
}
/////////////////////////////////////////////////////////////

// DESTRUKTORs
tArrayComplex3D_xyt::~tArrayComplex3D_xyt()
{
}
/////////////////////////////////////////////////////////////

//
//	erstelle 2 versch. inits einmal wird mit omegamin/max initialisiert, und s andre mal wird sich auf die zeit bezogen
//  besser anderen namen als init, wg missverstaendnissen... evtl. SetOmega und SetTime anbieten ...
// Init koennte nur Nr,Ntw setzen, da zum prinzipiellen betrieb die koordinaten nicht notwendig sind ... (nur f Ausgabe und evolve(omega)
// -> Init(Nr,Ntw);Init(Nr,Ntw,dr); SetRadiusVector(dr); 
//    SetOmegaVector(dw,wmin); SetTimeVector(dt,tmin); --> jeweils die anderen Params.berechnen und setzten
// Init_Time (Nr,Ntw,dr,tmin,dt); -> Init+SetTimeVector
// Init_Omega(Nr,Ntw,dr,tmin,dt); -> Init+SetOmegaVector  

// bei normalen init auch dr,dt,dw,etc =0 setzen, damit kein schmarrn drinsteht...

int tArrayComplex3D_xyt::SetCustomOmega(int inNtw, double inwmin, double inwmax)
{
	Ntw  = inNtw;
	wmin = inwmin;
	wmax = inwmax;


return 0;
}


int tArrayComplex3D_xyt::init(int inNr, int inNtw)
{
	
	Nr 	= inNr;
	Ntw	= inNtw;
	dr  = 0;
	rmax= 0;
	rmin= 0;
	dw  = 0;
	wmax= 0;
	wmin= 0;
	dt  = 0;
	tmax= 0;
	tmin= 0;
	
	data  = new Complex* [(Nr*Nr)];	
	for (ir=0;ir<(Nr*Nr);ir++) 	{ 
		data[ir] = new Complex [Ntw];
		for (jt=0;jt<Ntw;jt++) { data[ir][jt] = Complex(0,0); }  
	}
	
	fft1d.init(Ntw);
	
	return 0;
}

int tArrayComplex3D_xyt::init(int inNr, double inRmax, int inNtw, double inWmax)
{
	
	Nr 	= inNr;
	Ntw	= inNtw;
	
//	cout << " Set radius vector ..." << endl;
	rmax= inRmax;
    x0 = 0.5*rmax;
    y0 = 0.5*rmax;
	rmin= 0;
	dr	= rmax/(Nr-1);
	radius = new double [Nr];	for (ir=0;ir<Nr;ir++) { radius[ir] = ir*dr; }


/*//   ***   Set OMEGA- and TIME-Vector   ***

  N  =  even ! --> t=0 is not existent ...

 kc  =  kmax = N/2
wNyq = wmax = -wmin = 2PI /(2*dt)
 dw  = (wmax-wmin)/N = 2*wmax/N = 2PI/(N*dt)

 dt  = 2PI/(N*dw) ; cause of FFT-Nyquist-Theorem
 dt  = T/(N-1) = (tmax-tmin)/N-1  ; cause of N Points in T

tmax = (N-1)*dt - tmin;

If: tmax =: tm := -tmin -->  tm = (N-1)*dt / 2

t[0] = -tm = tmin ..... t[k] = -tm + k*dt .... t[N-1] = -tm + (N-1)*dt = -tm +2*tm = tm = tmax
w[0] = 0 ... w[1] = dw ... w[k<(N/2)] = k*dw ... w[k=(N/2)] = (+/-)wNyq ... w[k>(N/2)] = (k-N)*dw ... w[N-1] = -dw



*** EXAMPLE: ***

N = 8 ,  dt = 2PI  -->  wm = 1/2, dw = 1/8  , tm = (8-1)*2PI/2 = 7PI
        
        k  =    0    |   1  |   2  |   3  |      4      |   5  |   6  |   7   ||
      --------------------------------------------------------------------------------------
      w[k] =    0    | +1/8 | +2/8 | +3/8 |  (+/-) 1/2  | -3/8 | -2/8 | -1/8  ||
      --------------------------------------------------------------------------------------
      t[k] =  -7PI   | -5PI | -3PI | - PI |    + PI     | +3PI | +5PI | +7PI  ||  --> no k, so that t[k]=0, because of even N


//*/// ***   ***   ***   ***   ***   ***   ***



	time   = new double [Ntw];
	omega  = new double [Ntw];
// omega-interval determines t-interval
	 	   wmax =  inWmax ;
		   wmin = - wmax  ;
	 	   dw   =  (wmax-wmin) / Ntw ;
  ////////
	     dt   =  2*PI / (Ntw*dw); // see Nyquist-Theorem or above ...
	     tmin = -dt*0.5*(Ntw-1);
	     tmax = -tmin;
//*/////    

	double ww=0 ,  tt= tmax; tt = tmin;  /// tt zweimal belegt, wegen nerviger warnmeldung... kann wieder raus !!!
	for (jt=0;jt<=int(Ntw/2);jt++) {
	    	omega[jt] = ww;  
        	time[jt]  = tt;  			
		ww+=dw;tt+=dt;			
	}
	ww = wmin+dw; //-omega[int(Ntw/2)-1]; 
	for (jt=1+int(Ntw/2);jt<Ntw;jt++) {
   	        omega[jt] = ww;  
        	time[jt]  = tt;  
		ww+=dw;tt+=dt;			
	} 
/// ***** END of omega- and time-vector initialization



////  Initialize DATA-Array with ComplexZero = 0+0i
	data  = new Complex* [(Nr*Nr)];	
	for (ir=0;ir<(Nr*Nr);ir++) 	{ 
		data[ir] = new Complex [Ntw];
		for (jt=0;jt<Ntw;jt++) { data[ir][jt] = Complex(0,0); }  
	}
	
	fft1d.init(Ntw);
	
	return 0;
}


//*
int tArrayComplex3D_xyt::fft()
{
	for (ir=0;ir<(Nr*Nr);ir++) {  fft1d.fft(data[ir]); } 			//% Calc Ew1
	return 0;
}
//*/

//*
int tArrayComplex3D_xyt::ifft()
{
	for (ir=0;ir<(Nr*Nr);ir++) {  fft1d.ifft(data[ir]); } 			//% Calc Et1
	return 0;
}
//*/
// ****   Versch. Methoden um an Daten zu kommen ...
double tArrayComplex3D_xyt::power(int ir, int jt)
{
return data[ir][jt].real() * data[ir][jt].real() + data[ir][jt].imag() * data[ir][jt].imag();
}

double tArrayComplex3D_xyt::intensity(int ir, int jt) // [W/cm2]
{
// LIGHTSPEED	   =  299792458;        //  [ m/s ]
// EPSILON_ZERO   =  8.854187817e-12;  //  [ F/m ]

// I[W/m2] =  EPSILON_ZERO * LIGHTSPEED * |E|^2 
// I[W/cm2] =  1e-4 * I[W/m2]
 return ( 1e-4 * 8.854187817e-12 * 299792458 * power(ir,jt) ); 
}

double tArrayComplex3D_xyt::abs(int ir, int jt)
{
return sqrt(power(ir,jt));
}

Complex tArrayComplex3D_xyt::at(int ir, int jt)
{
return data[ir][jt];
}

double tArrayComplex3D_xyt::real(int ir, int jt)
{
return data[ir][jt].real();
}

double tArrayComplex3D_xyt::imag(int ir, int jt)
{
return data[ir][jt].imag();
}

double tArrayComplex3D_xyt::phi(int ir, int jt)
{
return arg( data[ir][jt] );
}

double tArrayComplex3D_xyt::phase(int ir, int jt)
{
return arg( data[ir][jt] );
}



//   3D STUFF
// ********************************************************************
// ********************************************************************
int tArrayComplex3D_xyt::index(int ix, int iy)
{
	return ix + Nr*iy;
}
// ********************************************************************
int tArrayComplex3D_xyt::Nxy()
{
	return Nr*Nr;
}
// ********************************************************************
// ********************************************************************
/******************************************************************************/
int tArrayComplex3D_xyt::SetBorders(Complex boundaryvalue)
{
	for (int jt=0; jt<Ntw; jt++ ) {
		for (int i=0; i<Nr; i++) // Nr=Nx
			{
			data[i][jt]	          = boundaryvalue; //  y=0  -> unterer  Rand
			data[i+Nr*(Nr-1)][jt] = boundaryvalue; //  y=Nr -> oberer  Rand
		//}
		//for (int i=0; i<Nr; i++) // Nr=Ny
		//	{
			data[Nr*i][jt]        = boundaryvalue; //  x=0  -> rechter Rand
			data[(Nr-1)+Nr*i][jt] = boundaryvalue; //  x=Nr -> linker  Rand
		}
	}
	return 0;
}
/******************************************************************************/



