// Author: Torsten.Leitner@email.de
// (c) 2006/2007


#ifndef TARRAYCOMPLEX3D_XYT_H_
#define TARRAYCOMPLEX3D_XYT_H_



#include <stdio.h>
#include <iostream>
#include <iomanip>
#include <fstream>
#include <string>
#include <math.h>
#include <complex>
#include <vector>
#include <sstream>
#include <fftw3.h>
#include "Definitions.h"
#include "fftw_fft.h"

#include "InAndOut.h"

using namespace std;



class tArrayComplex3D_xyt
{

public:

//constructors
	tArrayComplex3D_xyt();
	tArrayComplex3D_xyt(int inNr, int inNtw);
	tArrayComplex3D_xyt(int inNr, double inRmax, int inNtw, double inWmax);
//destructors
	virtual ~tArrayComplex3D_xyt();
	
//functions

	int init(int inNr, int inNtw);
	int init(int inNr, double inRmax, int inNtw, double inWmax);
	
	int SetCustomOmega(int inNtw, double inwmin, double inwmax);

	int  fft();
	int ifft();
	
	double power(int ir, int jt);
	
	double intensity(int ir, int jt);  // [W/cm2]

	double abs(int ir, int jt);

	Complex at(int ir, int jt);

	double real(int ir, int jt);

	double imag(int ir, int jt);
	
	
// these are equal ...	
	double phase(int ir, int jt);
	double phi(int ir, int jt);
// ********************************	
	
	
/// 3D STUFF
	int index(int ix, int iy);
	int Nxy();
	int SetBorders(Complex boundaryvalue);
/// 3D STUFF		
	
	
//variables
		
	int Nr;
	int Ntw;
	
	double *radius,dr,rmin,rmax;
	double x0,  y0;
	
	double *time,  dt,tmin,tmax;
	double *omega, dw,wmin,wmax;
		
	Complex **data;
	
private:

//variables
	int   ir,jt;
	class fftw_fft1d fft1d;

//functions
	

};


#endif /*TARRAYCOMPLEX3D_XYT_H_*/

