//
// Author: Torsten.Leitner@email.de
// (c) 2006/2007
//

#include "evolve.h"

using namespace std;


// ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
//*   With    class tArrayComplex2D_rt
int evolve2d_fullAU(int nsteps, double dzAU, class tArrayComplex2D_rt *u, class tArrayComplex2D_rt *source)
{ 	
//
 	int k,ir,jt;
	int   Nr  = u->Nr;
	int   Ntw = u->Ntw;
//	double dr = u->dr;
	double h2 = (u->dr)*(u->dr);
//
	Complex alpha[Nr-1],beta[Nr-1],gamma[Nr-1],b[Nr-1];
	Complex D, lam, shortermmemory;
//
	Complex CmplxOne(1,0);
//
//	u->data[Nr-1]=0;
//
for (k=0;k<nsteps;k++) {  // Loop over nsteps with the same Source-Term
//	
	for (jt=1;jt<Ntw-1;jt++) {  // Loop over all w/t-Slices ...
//    
 		D=Complex(0,-0.5*CLIGHT_AU/u->omega[jt]);  	// Diffusion Const depending on omega(jt)
//
		lam = D * dzAU / h2;
//
		// This loop applies the new RightHandSide (rhs) b  and
		//	 the non-zero matrixelements: alpha[j],beta[j],gamma[j]
		alpha[0]  =  0 ; // alpha[0] is not existent and not used in the latter ...
		beta [0]  = CmplxOne + 4.0*lam ;
		gamma[0]  = - 4.0 *lam ;
		b    [0]  = ( CmplxOne - 4.0*lam ) * u->data[0][jt]   + 4.0*lam * u->data[1][jt]  - D*dzAU*source->data[0][jt];
//
		for (ir=1;ir<Nr-1;ir++)
		{  	
			alpha[ir]  =  - 0.5*( 1 - ( 1/(2*ir) ) )*lam   ;
			beta [ir]  = CmplxOne + lam ;
			gamma[ir]  =  - 0.5*( 1 + ( 1/(2*ir) ) )*lam ;
			b    [ir]  = ( CmplxOne - lam ) * u->data[ir][jt]   
				    + 0.5*(  Complex((1+(1/(2*ir))),0) * u->data[ir+1][jt]  
					        +Complex((1-(1/(2*ir))),0) * u->data[ir-1][jt] ) * lam  - D*dzAU*source->data[ir][jt];
		} 
//
		// Forward Recursion to get rid off all Elements lower than the diagonal...
		for (ir=1;ir<Nr-1;ir++)
		{ 
			shortermmemory = ( alpha[ir]/beta[ir-1] ) ;
//			alpha[ir] = alpha[ir] - ( alpha[ir]/beta[ir-1] ) * beta[ir-1] ;//  = 0
			beta[ir]  = beta[ir]  - shortermmemory * gamma[ir-1];
//			gamma[ir] = gamma[ir] - ( alpha[ir]/beta[ir-1] ) * 0 =  gamma[ir] ;
			b[ir] 	  = b[ir]     - shortermmemory * b[ir-1];		  
		}
//		
		// Backward Recursion ...
		u->data[Nr-1][jt] =    0;
	        u->data[Nr-2][jt] =    b[Nr-2] / beta[Nr-2];
		for (ir=Nr-3;ir>=0;ir--){  u->data[ir][jt]    = ( b[ir] - gamma[ir]*u->data[ir+1][jt] ) / beta[ir]; }
//
 	} // END of t/w-slices-loop
} // END of nsteps-loop 
 	return 0;
}
// ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
// ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
// ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
//*/



// ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
//*   With    class tArrayComplex2D_rt
int evolve2d(int nsteps, double dz, class tArrayComplex2D_rt *u, class tArrayComplex2D_rt *source)
{ 	
//
 	int k,ir,jt;
	int   Nr  = u->Nr;
	int   Ntw = u->Ntw;
//	double dr = u->dr;
	double h2 = (u->dr)*(u->dr);
//
	Complex alpha[Nr-1],beta[Nr-1],gamma[Nr-1],b[Nr-1];
	Complex D, lam, shortermmemory;
//
	Complex CmplxOne(1,0);
//
//	u->data[Nr-1]=0;
//
for (k=0;k<nsteps;k++) {  // Loop over nsteps with the same Source-Term
//	
	for (jt=1;jt<Ntw-1;jt++) {  // Loop over all w/t-Slices ...
//    
 		D=Complex(0,-0.5*CLIGHT/u->omega[jt]);  	// Diffusion Const depending on omega(jt)
//
		lam = D * dz / h2;
//
		// This loop applies the new RightHandSide (rhs) b  and
		//	 the non-zero matrixelements: alpha[j],beta[j],gamma[j]
		alpha[0]  =  0 ; // alpha[0] is not existent and not used in the latter ...
		beta [0]  = CmplxOne + 4.0*lam ;
		gamma[0]  = - 4.0 *lam ;
		b    [0]  = ( CmplxOne - 4.0*lam ) * u->data[0][jt]   + 4.0*lam * u->data[1][jt]  - D*dz*source->data[0][jt];
//
		for (ir=1;ir<Nr-1;ir++)
		{  	
			alpha[ir]  =  - 0.5*( 1 - ( 1/(2*ir) ) )*lam   ;
			beta [ir]  = CmplxOne + lam ;
			gamma[ir]  =  - 0.5*( 1 + ( 1/(2*ir) ) )*lam ;
			b    [ir]  = ( CmplxOne - lam ) * u->data[ir][jt]   
				    + 0.5*(  Complex((1+(1/(2*ir))),0) * u->data[ir+1][jt]  
					        +Complex((1-(1/(2*ir))),0) * u->data[ir-1][jt] ) * lam  - D*dz*source->data[ir][jt];
		} 
//
		// Forward Recursion to get rid off all Elements lower than the diagonal...
		for (ir=1;ir<Nr-1;ir++)
		{ 
			shortermmemory = ( alpha[ir]/beta[ir-1] ) ;
//			alpha[ir] = alpha[ir] - ( alpha[ir]/beta[ir-1] ) * beta[ir-1] ;//  = 0
			beta[ir]  = beta[ir]  - shortermmemory * gamma[ir-1];
//			gamma[ir] = gamma[ir] - ( alpha[ir]/beta[ir-1] ) * 0 =  gamma[ir] ;
			b[ir] 	  = b[ir]     - shortermmemory * b[ir-1];		  
		}
//		
		// Backward Recursion ...
		u->data[Nr-1][jt] =    0;
	        u->data[Nr-2][jt] =    b[Nr-2] / beta[Nr-2];
		for (ir=Nr-3;ir>=0;ir--){  u->data[ir][jt]    = ( b[ir] - gamma[ir]*u->data[ir+1][jt] ) / beta[ir]; }
//
 	} // END of t/w-slices-loop
} // END of nsteps-loop 
 	return 0;
}
// ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
// ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
// ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
//*/







// ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
// ccccccccccccccc     EVOVLE3D via evolve3d_halstep_x/y     cccccccccccccccccccccccccccccccccccccccc
// ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc

// ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
int evolve3d_FTCS( int nsteps, double dz, class tArrayComplex3D_xyt *u, class tArrayComplex3D_xyt *source )
{
/// Forward Time Centered Space -> u'(x,y) = u(x,y) + dz*(D/h2)*( Sum(neigbors) - 2u(x,y) ) 

int  Nr = u->Nr;

Complex D,a;

double dr = u->dr; // dx=dy==dr !!!

int xx,yy;

for (int k = 0 ; k < nsteps ; k++ )  // loop over n-steps
{
			
	for (int jt=1;jt<u->Ntw;jt++) {  // Loop over all w-Slices ...
	
 		D = Complex(0,-0.5*CLIGHT/u->omega[jt]);  	
 		a = D * dz / (dr*dr) ;
 					
		u->SetBorders( Complex(0,0) );
		
		for (xx=1;xx<Nr-1;xx++) {      // alle inneren Punkte x
			for (yy=1;yy<Nr-1;yy++) {  // alle inneren Punkte y

				source->data[ u->index(xx,yy) ][jt] 	 
						= u->data[u->index(xx,yy)][jt]   
						  +       a *  (         u->data[ u->index(xx,yy-1) ][jt] 
						                 +       u->data[ u->index(xx,yy+1) ][jt]
						                 +       u->data[ u->index(xx+1,yy) ][jt]
						                 +       u->data[ u->index(xx-1,yy) ][jt] 	
						                 - 4.0 * u->data[ u->index(xx,yy)   ][jt]  ) ;
		
			}
		}
		
		for (xx=1;xx<Nr-1;xx++) {      // alle inneren Punkte x
			for (yy=1;yy<Nr-1;yy++) {  // alle inneren Punkte y
				u->data[u->index(xx,yy)][jt] = source->data[ u->index(xx,yy) ][jt]; 	 
			}
		}
				
		

	}
}
	return 0;
}
// ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc


// ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
int evolve3d( int nsteps, double dz, class tArrayComplex3D_xyt *u, class tArrayComplex3D_xyt *source )
{
/// ADI-Method: Alternating Direction Integration ... combinded with Crank-Nicolson

int  Nr = u->Nr;

int idx = 1;
int idy = Nr;
Complex DiffusionConstant;

double dr = u->dr; // dx=dy==dr !!!


Complex alpha , beta0, *beta, *b; 
beta = new Complex[(Nr-2)*(Nr-2)];
b    = new Complex[(Nr-2)*(Nr-2)];


for (int k = 0 ; k < nsteps ; k++ )
{
			
//	for (int jt=1;jt<u->Ntw;jt++) {  // Loop over all w-Slices with w neq 0
	for (int jt=1;jt<int(0.5*u->Ntw);jt++) {  // Loop over all w-Slices with 0 < w < +wmax  
	
 		DiffusionConstant = Complex(0,-0.5*CLIGHT/u->omega[jt]);  	
 		alpha = 0.5 * DiffusionConstant * dz / (dr*dr);
 		beta0 = Complex(1,0) + 2.0 * alpha;			

//cout << " Step : " << k+0.5 << endl;

			u->SetBorders( Complex(0,0) );
			evolve3d_halfstep_x( dz , u , source, idx, idy, jt, alpha, beta0 , beta , b );


//cout << " Step : " << k+1 << endl;

			u->SetBorders( Complex(0,0) );
			evolve3d_halfstep_y( dz , u , source, idx, idy, jt, alpha, beta0 , beta , b );

	}
}
	return 0;
}
// ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc

// version with (2iw/c)*du/dz= ...
// ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
int evolve3d_halfstep_x( double dz, class tArrayComplex3D_xyt *u, class tArrayComplex3D_xyt *source 
							,const int idx, const int idy,const int jt
							, const Complex alpha, const Complex beta0, Complex *beta, Complex *b )
{
	
		// u has one Element more: u[Nxy]=0, so we have Dirichlet-Boundary-Conditions with running over all inner Points (j<Nxy)
	// u[Nxy]=0;
//  			              (beta0 , gamma0, 0			   				    )
//	Matrixequation:  A*u =    (alpha1, beta1 , gamma1 , 0			     	    )*u  =   b(old_u) ;
//        					  ( 0	, alpha2, beta2  , gamma2 , 0				)
//					          ( ............................................... )
//
// This is a Crank-Nicolson-Routine (CrN):
// un: new u --- uo: old u ,,,, a=alpha,b=beta,g=gamma
//
// ->  un(j) + { a(j)un(j-1) + b(j)un(j) + g(j)un(j+1) } =  uo(j) - { a(j)uo(j-1) + b(j)uo(j) + g(j)uo(j+1) }
//
//	In textbooks they usually define it different... here: all DiffusionConstants, like (1/2) and the discretization 
//														   are include in the a,b,g s ...
//			->  D = (1/2)*( dz / h^2 ) ; .... in this prog: h=dr; 
//  Note that dz is refered as dt in the diffusion-equations in textbooks ...
// 






//alpha = 0.5 * DiffusionConstant * dz / (dr*dr);
//beta0 = Complex(1,0) + 2.0 * alpha;			


int j=0,yy=0,xx=0;

int Nr = u->Nr;
double h = u->dr , h2 =h*h;
double adi=0.5;

Complex prefacdudz = Complex(0,2*u->omega[jt]/CLIGHT);  //(2iw/c) du/dz

//	int xxmin=1;	int xxmax=Nr-2; // diese grenzen produzieren singularitaeten ... u->infty
int xxmin=0;	int xxmax=Nr-1;     // diese stillstand ???


Complex bet0 = prefacdudz - dz*adi/h2 ;
Complex alph = -0.5*dz*adi/h2 ;
Complex gamm = alpha ;

for (yy=1;yy<Nr-1;yy++) {  // Main loop über alle Zeilen  x
	
	
	// Supply right-hand-side b
	for (xx=xxmin;xx<xxmax+1;xx++) {    // xx= 1..N-2 -> xx=j+1
		j = xx-1;	
		b[j] 	 = (prefacdudz - dz*adi/h2 ) * u->data[ u->index(xx,yy) ][jt]   
		         + 0.5*dz*adi/h2 * (  u->data[ u->index(xx,yy-1) ][jt] 
						            + u->data[ u->index(xx,yy+1) ][jt] 	) ;
	}
	
	// Forward Recursion to get rid off all Elements lower than the diagonal...
	beta[0] = bet0;

	for (j=1;j<xxmax;j++)   // jmax+1 = (xxmax-1)+1 = xxmax  
		{ 
		beta[j] = bet0 - gamm * alph / beta[j-1];   // beta[j] = beta0 initially  
		b[j] 	= b[j]  - b[j-1] * alph / beta[j-1] ; 
		}
		
	// Backward Recursion ...
	j=xxmax-1; // jmax = xxmax-1  
	u->data[ u->index(j+1,yy) ][jt] =  b[j] / beta[j];  
	for (j=xxmax-2;j>=0;j--) 
		{  		// xx= N-2..1 -> xx=j+1
			u->data[ u->index(j+1,yy) ][jt] = ( b[j] - gamm * u->data[ u->index(j+2,yy) ][jt] ) / beta[j];  
		}

//*/
} // end main loop over all y
// finished ... evolve_x_step();	

 	return 0;
}
// ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc


// ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
int evolve3d_halfstep_y( double dz, class tArrayComplex3D_xyt *u, class tArrayComplex3D_xyt *source 
							,const int idx, const int idy,const int jt
							, const Complex alpha, const Complex beta0, Complex *beta, Complex *b )
{
	
		// u has one Element more: u[Nxy]=0, so we have Dirichlet-Boundary-Conditions with running over all inner Points (j<Nxy)
	// u[Nxy]=0;
//  			              (beta0 , gamma0, 0			   				    )
//	Matrixequation:  A*u =    (alpha1, beta1 , gamma1 , 0			     	    )*u  =   b(old_u) ;
//        					  ( 0	, alpha2, beta2  , gamma2 , 0				)
//					          ( ............................................... )
//
// This is a Crank-Nicolson-Routine (CrN):
// un: new u --- uo: old u ,,,, a=alpha,b=beta,g=gamma
//
// ->  un(j) + { a(j)un(j-1) + b(j)un(j) + g(j)un(j+1) } =  uo(j) - { a(j)uo(j-1) + b(j)uo(j) + g(j)uo(j+1) }
//
//	In textbooks they usually define it different... here: all DiffusionConstants, like (1/2) and the discretization 
//														   are include in the a,b,g s ...
//			->  D = (1/2)*( dz / h^2 ) ; .... in this prog: h=dr; 
//  Note that dz is refered as dt in the diffusion-equations in textbooks ...
// 


int j=0,yy=0,xx=0;

int Nr = u->Nr;
double h = u->dr , h2 =h*h;
double adi=0.5;

Complex prefacdudz = Complex(0,2*u->omega[jt]/CLIGHT);  //(2iw/c) du/dz

//	int yymin=1;	int yymax=Nr-2; // diese grenzen produzieren singularitaeten ... u->infty
	int yymin=0;	int yymax=Nr-1;

Complex bet0 = prefacdudz - dz*adi/h2 ;
Complex alph = -0.5*dz*adi/h2 ;
Complex gamm = alpha ;

for (xx=1;xx<Nr-1;xx++) {  // Main loop über alle Zeilen  x
	
	
	// Supply right-hand-side b
	for (yy=yymin;yy<yymax+1;yy++) {    // yy= 1..N-2 -> yy=j+1
		j = yy-1;	
		b[j] 	 = (prefacdudz - dz*adi/h2 ) * u->data[ u->index(xx,yy) ][jt]   
		         + 0.5*dz*adi/h2 * (  u->data[ u->index(xx-1,yy) ][jt] 
						            + u->data[ u->index(xx+1,yy) ][jt] 	) ;
	}
	
	// Forward Recursion to get rid off all Elements lower than the diagonal...
	beta[0] = bet0;

	for (j=1;j<yymax;j++)   // jmax+1 = (yymax-1)+1 = yymax  
		{ 
		beta[j] = bet0 - gamm * alph / beta[j-1];   // beta[j] = beta0 initially  
		b[j] 	= b[j]  - b[j-1] * alph / beta[j-1] ; 
		}
		
	// Backward Recursion ...
	j=yymax-1; // jmax = yymax-1  
	u->data[ u->index(xx,j+1) ][jt] =  b[j] / beta[j];  
	for (j=yymax-2;j>=0;j--) 
		{  		// xx= N-2..1 -> xx=j+1
			u->data[ u->index(xx,j+1) ][jt] = ( b[j] - gamm * u->data[ u->index(xx,j+2) ][jt] ) / beta[j];  
		}

//*/
} // end main loop over all y
// finished ... evolve_x_step();	

 	return 0;
}
// ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
/*
  
// version with 1*du/dz= (c/2iw)*...
// ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
int evolve3d_halfstep_x( double dz, class tArrayComplex3D_xyt *u, class tArrayComplex3D_xyt *source 
							,const int idx, const int idy,const int jt
							, const Complex alpha, const Complex beta0, Complex *beta, Complex *b )
{
	
		// u has one Element more: u[Nxy]=0, so we have Dirichlet-Boundary-Conditions with running over all inner Points (j<Nxy)
	// u[Nxy]=0;
//  			              (beta0 , gamma0, 0			   				    )
//	Matrixequation:  A*u =    (alpha1, beta1 , gamma1 , 0			     	    )*u  =   b(old_u) ;
//        					  ( 0	, alpha2, beta2  , gamma2 , 0				)
//					          ( ............................................... )
//
// This is a Crank-Nicolson-Routine (CrN):
// un: new u --- uo: old u ,,,, a=alpha,b=beta,g=gamma
//
// ->  un(j) + { a(j)un(j-1) + b(j)un(j) + g(j)un(j+1) } =  uo(j) - { a(j)uo(j-1) + b(j)uo(j) + g(j)uo(j+1) }
//
//	In textbooks they usually define it different... here: all DiffusionConstants, like (1/2) and the discretization 
//														   are include in the a,b,g s ...
//			->  D = (1/2)*( dz / h^2 ) ; .... in this prog: h=dr; 
//  Note that dz is refered as dt in the diffusion-equations in textbooks ...
// 


int j,yy ; //,xx

int Nr = u->Nr;

for (yy=1;yy<Nr-1;yy++) {  // Main loop über alle Zeilen  x
	
	// Supply right-hand-side b
	for (j=0;j<Nr-2;j++) {    // xx= 1..N-2 -> xx=j+1

			b[j] 	 = u->data[u->index(j+1,yy)][jt]   + alpha * 
						               (        u->data[ u->index(j+1,yy-1) ][jt] 
						                - 2.0 * u->data[ u->index(j+1,yy)   ][jt] 
						                +       u->data[ u->index(j+1,yy+1) ][jt] 	) ;
	}
	
		

	// Forward Recursion to get rid off all Elements lower than the diagonal...
	beta[0] = beta0;

	for (j=1;j<Nr-2;j++) 
		{ 
		beta[j] = beta0 - alpha * alpha / beta[j-1];   // beta[j] = beta0 initially  
		b[j] 	= b[j]  + alpha *  b[j-1] / beta[j-1] ; 
		}
		
// Backward Recursion ...
	

	j=Nr-2;
	u->data[ u->index(j+1,yy) ][jt] =  b[j] / beta[j];  
	for (j=Nr-3;j>0;j--) 
		{  		// xx= N-2..1 -> xx=j+1
			u->data[ u->index(j+1,yy) ][jt] = ( b[j] - alpha * u->data[ u->index(j+2,yy) ][jt] ) / beta[j];  
		}


} // end main loop over all y
// finished ... evolve_x_step();	

 	return 0;
}
// ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc


// ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
int evolve3d_halfstep_y( double dz, class tArrayComplex3D_xyt *u, class tArrayComplex3D_xyt *source 
							,const int idx, const int idy,const int jt
							, const Complex alpha, const Complex beta0, Complex *beta, Complex *b )
{
	
		// u has one Element more: u[Nxy]=0, so we have Dirichlet-Boundary-Conditions with running over all inner Points (j<Nxy)
	// u[Nxy]=0;
//  			              (beta0 , gamma0, 0			   				    )
//	Matrixequation:  A*u =    (alpha1, beta1 , gamma1 , 0			     	    )*u  =   b(old_u) ;
//        					  ( 0	, alpha2, beta2  , gamma2 , 0				)
//					          ( ............................................... )
//
// This is a Crank-Nicolson-Routine (CrN):
// un: new u --- uo: old u ,,,, a=alpha,b=beta,g=gamma
//
// ->  un(j) + { a(j)un(j-1) + b(j)un(j) + g(j)un(j+1) } =  uo(j) - { a(j)uo(j-1) + b(j)uo(j) + g(j)uo(j+1) }
//
//	In textbooks they usually define it different... here: all DiffusionConstants, like (1/2) and the discretization 
//														   are include in the a,b,g s ...
//			->  D = (1/2)*( dz / h^2 ) ; .... in this prog: h=dr; 
//  Note that dz is refered as dt in the diffusion-equations in textbooks ...
// 


int j,xx ; //,xx

int Nr = u->Nr;

for (xx=1;xx<Nr-1;xx++) {  // Main loop über alle Zeilen  x
	
	// Supply right-hand-side b
	for (j=0;j<Nr-2;j++) {    // yy= 1..N-2 -> yy=j+1

			b[j] 	 = u->data[u->index(xx,j+1)][jt]   + alpha * 
						               (        u->data[ u->index(xx-1,j+1) ][jt] 
						                - 2.0 * u->data[ u->index(xx,j+1)   ][jt] 
						                +       u->data[ u->index(xx+1,j+1) ][jt] 	) ;
	}
	
		

	// Forward Recursion to get rid off all Elements lower than the diagonal...
	beta[0] = beta0;

	for (j=1;j<Nr-2;j++) 
		{ 
		beta[j] = beta0 - alpha * alpha / beta[j-1];   // beta[j] = beta0 initially  
		b[j] 	= b[j]  + alpha *  b[j-1] / beta[j-1] ; 
		}
		
// Backward Recursion ...
	

	j=Nr-2;
	u->data[ u->index(xx,j+1) ][jt] =  b[j] / beta[j];  
	for (j=Nr-3;j>0;j--) 
		{  		// yy= N-2..1 -> yy=j+1
			u->data[ u->index(xx,j+1) ][jt] = ( b[j] - alpha * u->data[ u->index(xx,j+2) ][jt] ) / beta[j];  
		}


} // end main loop over all y
// finished ... evolve_x_step();	

 	return 0;
}
// ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc



//*//////
/*


// ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
int evolve3d_halfstep_x( double dz, class tArrayComplex3D_xyt *u, class tArrayComplex3D_xyt *source 
							,const int idx, const int idy,const int jt
							, const Complex alpha, const Complex beta0, Complex *beta, Complex *b )
{
	
		// u has one Element more: u[Nxy]=0, so we have Dirichlet-Boundary-Conditions with running over all inner Points (j<Nxy)
	// u[Nxy]=0;
//  			              (beta0 , gamma0, 0			   				    )
//	Matrixequation:  A*u =    (alpha1, beta1 , gamma1 , 0			     	    )*u  =   b(old_u) ;
//        					  ( 0	, alpha2, beta2  , gamma2 , 0				)
//					          ( ............................................... )
//
// This is a Crank-Nicolson-Routine (CrN):
// un: new u --- uo: old u ,,,, a=alpha,b=beta,g=gamma
//
// ->  un(j) + { a(j)un(j-1) + b(j)un(j) + g(j)un(j+1) } =  uo(j) - { a(j)uo(j-1) + b(j)uo(j) + g(j)uo(j+1) }
//
//	In textbooks they usually define it different... here: all DiffusionConstants, like (1/2) and the discretization 
//														   are include in the a,b,g s ...
//			->  D = (1/2)*( dz / h^2 ) ; .... in this prog: h=dr; 
//  Note that dz is refered as dt in the diffusion-equations in textbooks ...
// 


int j,xx,yy ;

int Nr = u->Nr;

	j=0;
	for (xx=1;xx<Nr-1;xx++) {
		for (yy=1;yy<Nr-1;yy++) {

			b[j] 	 = u->data[u->index(xx,yy)][jt]   + 0.5*alpha * 
						              (         u->data[ u->index(xx,yy-1) ][jt] 
						                - 2.0 * u->data[ u->index(xx,yy)   ][jt] 
						                +       u->data[ u->index(xx,yy+1) ][jt] 	) ;
			j++;
		}
	}
		

// Merke:  j = ix + Nx*iy
// Forward Recursion to get rid off all Elements lower than the diagonal...

	beta[0] = beta0;

	for (j=1;j<((Nr-2)*(Nr-2));j++) 
		{ 
//		beta[j] = beta0 - alpha * alpha * beta[j-1];
		beta[j] = beta0 - 0.25*alpha * alpha / beta[j-1];   // beta[j] = beta0 initially  
		b[j] 	= b[j]  + 0.5 * alpha *  b[j-1] / beta[j-1] ; 
		}
		
// Backward Recursion ...
	
	j=(Nr-2)*(Nr-2)-1;

//	u->data[ u->index(Nr-1,Nr-1) ][jt] = b[j] / beta[j];

	for (xx=Nr-1;xx>0;xx--) {
		for (yy=Nr-1;yy>0;yy--) {
			j--;
			u->data[ u->index(xx,yy) ][jt] = ( b[j] - alpha * u->data[ u->index(xx+1,yy) ][jt] ) / beta[j];  
		}
	}

// finished ... evolve_x_step();	
 	return 0;
}
// ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc


// ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
int evolve3d_halfstep_y( double dz, class tArrayComplex3D_xyt *u, class tArrayComplex3D_xyt *source 
							,const int idx, const int idy,const int jt
							, const Complex alpha, const Complex beta0, Complex *beta, Complex *b )

{
	

int j,xx,yy ;

int Nr = u->Nr;


	for (xx=1;xx<Nr-2;xx++) {
		for (yy=1;yy<Nr-2;yy++) {
			b[u->index(xx,yy)] 	 = u->data[u->index(xx,yy)][jt]   - 0.5*alpha * 
						              (         u->data[ u->index(xx-1,yy) ][jt] 
						                - 2.0 * u->data[ u->index(xx,yy)   ][jt] 
						                +       u->data[ u->index(xx+1,yy) ][jt] 	) ;
		}
	}
		

// Merke:  j = ix + Nx*iy
// Forward Recursion to get rid off all Elements lower than the diagonal...
	for (j=0;j<idy;j++) 
		{ 
//		beta[j] = 1.0/beta0;
		beta[j] = beta0;
		}
	for (j=idy;j<(Nr*Nr);j++) 
		{ 
//		beta[j] = beta0 - alpha * alpha * beta[j-1];
		beta[j] = beta0 - 0.25*alpha * alpha / beta[j-1];   // beta[j] = beta0 initially  
		b[j] 	= b[j]  +0.5* alpha *  b[j-idy] / beta[j-idy] ; 
		}
		
// Backward Recursion ...
	u->data[(Nr*Nr)-1][jt] = b[(Nr*Nr)-1] / beta[(Nr*Nr)-1];
//	u->data[(Nr*Nr)-2][jt] = b[(Nr*Nr)-2] / beta[(Nr*Nr)-2];
	for (j=(Nr*Nr)-1-idy;j>=0;j--) 
		{ 
			u->data[j][jt] = ( b[j] - alpha * u->data[ j+idy ][jt] ) / beta[j];  
		}
// finished ... evolve_y_step();	
	
	
 	return 0;
}
// ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
// ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc

//*////////


