// Author: Torsten.Leitner@email.de
// (c) 2006/2007

#ifndef TMPTMP_H_
#define TMPTMP_H_

#include "tArrayComplex2D_rt.h"



bool TestLaserBigEnoughForDipoleMoment(class tArrayComplex2D_rt *Laser , int ir, double threshold);


inline complex<double> DipoleMatrixElement_hydrogen_like_1D(const double p,  const double Ip);



int CalcVecPotAndIntegralsfullau(class tArrayComplex2D_rt *Et, Complex *A, Complex *H, Complex *Y , const int ir );
	// INTEGRAL_METHOD

int CalcDipoleMomentXtfullau( Complex *xt , class tArrayComplex2D_rt *Et, Complex *A, Complex *IntA, Complex *IntA2, 
					 	const int ir, const int Ntw, const double Ip_eV, const int Npoints2integrateXt)   ;





inline Complex CalcDipMomXtfullau_integrand(const int jt, const int jy ,class tArrayComplex2D_rt *Et, Complex *A, Complex *IntA, Complex *IntA2, 
					 	const int ir, const double Ip_AU, const double dt) ;

int CalcVecPotAndIntegralsfullau_higherorderintegration(class tArrayComplex2D_rt *Et, Complex *A, Complex *H, Complex *Y , const int ir );
	// INTEGRAL_METHOD

int CalcDipoleMomentXtfullau_higherorderintegration( Complex *xt , class tArrayComplex2D_rt *Et, Complex *A, Complex *IntA, Complex *IntA2, 
					 	const int ir, const int Ntw, const double Ip_eV, const int Npoints2integrateXt)   ;







// From here.. with full fields A intA and so on ...

// ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc         
int CalcVecPotAndIntegrals(class tArrayComplex2D_rt *Et, class tArrayComplex2D_rt *A,
						   class tArrayComplex2D_rt *H,  class tArrayComplex2D_rt *Y )
	;   // dummy function which calls one of those methods						  
int CalcVecPotAndIntegrals_int(class tArrayComplex2D_rt *Et, class tArrayComplex2D_rt *A,
						       class tArrayComplex2D_rt *H,  class tArrayComplex2D_rt *Y )
	; 	// INTEGRAL_METHOD
int CalcVecPotAndIntegrals_fft(class tArrayComplex2D_rt *E, class tArrayComplex2D_rt *A,
						       class tArrayComplex2D_rt *H, class tArrayComplex2D_rt *Y)
	;	// FFT		          // H:=Int[A] --- Y:=Int[A^2]
// ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc


// ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
int CalcDipoleMoment( 	Complex *xt, 
						class tArrayComplex2D_rt *Et,   class tArrayComplex2D_rt *A, 
						class tArrayComplex2D_rt *IntA, class tArrayComplex2D_rt *IntA2, 
					 	const int ir, const int Ntw1, const double dt, 
					 	const double omega0, const double Ip) ;
// ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc

// ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
int CalcNonLinSrc(class tArrayComplex2D_rt *Et, class tArrayComplex2D_rt *SrcH, const double omega0, const double Ip);
// ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc




#endif /*TMPTMP_H_*/
